<?php

/**
 * Event filter form base class.
 *
 * @package    Kiwi
 * @subpackage filter
 * @author     Your name here
 */
abstract class BaseEventFormFilter extends BaseFormFilterPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'is_calendar'   => new sfWidgetFormChoice(array('choices' => array('' => 'yes or no', 1 => 'yes', 0 => 'no'))),
      'is_published'  => new sfWidgetFormChoice(array('choices' => array('' => 'yes or no', 1 => 'yes', 0 => 'no'))),
      'title'         => new sfWidgetFormFilterInput(array('with_empty' => false)),
      'latitude'      => new sfWidgetFormFilterInput(),
      'longitude'     => new sfWidgetFormFilterInput(),
      'address'       => new sfWidgetFormFilterInput(),
      'content'       => new sfWidgetFormFilterInput(array('with_empty' => false)),
      'short_content' => new sfWidgetFormFilterInput(),
      'starts_at'     => new sfWidgetFormFilterDate(array('from_date' => new sfWidgetFormDate(), 'to_date' => new sfWidgetFormDate())),
      'finishes_at'   => new sfWidgetFormFilterDate(array('from_date' => new sfWidgetFormDate(), 'to_date' => new sfWidgetFormDate())),
      'created_at'    => new sfWidgetFormFilterDate(array('from_date' => new sfWidgetFormDate(), 'to_date' => new sfWidgetFormDate(), 'with_empty' => false)),
      'image'         => new sfWidgetFormFilterInput(),
      'category_id'   => new sfWidgetFormPropelChoice(array('model' => 'NewsCategory', 'add_empty' => true)),
      'project_id'    => new sfWidgetFormPropelChoice(array('model' => 'Projects', 'add_empty' => true)),
    ));

    $this->setValidators(array(
      'is_calendar'   => new sfValidatorChoice(array('required' => false, 'choices' => array('', 1, 0))),
      'is_published'  => new sfValidatorChoice(array('required' => false, 'choices' => array('', 1, 0))),
      'title'         => new sfValidatorPass(array('required' => false)),
      'latitude'      => new sfValidatorPass(array('required' => false)),
      'longitude'     => new sfValidatorPass(array('required' => false)),
      'address'       => new sfValidatorPass(array('required' => false)),
      'content'       => new sfValidatorPass(array('required' => false)),
      'short_content' => new sfValidatorPass(array('required' => false)),
      'starts_at'     => new sfValidatorDateRange(array('required' => false, 'from_date' => new sfValidatorDate(array('required' => false)), 'to_date' => new sfValidatorDate(array('required' => false)))),
      'finishes_at'   => new sfValidatorDateRange(array('required' => false, 'from_date' => new sfValidatorDate(array('required' => false)), 'to_date' => new sfValidatorDate(array('required' => false)))),
      'created_at'    => new sfValidatorDateRange(array('required' => false, 'from_date' => new sfValidatorDate(array('required' => false)), 'to_date' => new sfValidatorDate(array('required' => false)))),
      'image'         => new sfValidatorPass(array('required' => false)),
      'category_id'   => new sfValidatorPropelChoice(array('required' => false, 'model' => 'NewsCategory', 'column' => 'id')),
      'project_id'    => new sfValidatorPropelChoice(array('required' => false, 'model' => 'Projects', 'column' => 'id')),
    ));

    $this->widgetSchema->setNameFormat('event_filters[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'Event';
  }

  public function getFields()
  {
    return array(
      'id'            => 'Number',
      'is_calendar'   => 'Boolean',
      'is_published'  => 'Boolean',
      'title'         => 'Text',
      'latitude'      => 'Text',
      'longitude'     => 'Text',
      'address'       => 'Text',
      'content'       => 'Text',
      'short_content' => 'Text',
      'starts_at'     => 'Date',
      'finishes_at'   => 'Date',
      'created_at'    => 'Date',
      'image'         => 'Text',
      'category_id'   => 'ForeignKey',
      'project_id'    => 'ForeignKey',
    );
  }
}
