<?php

/**
 * Foundation filter form base class.
 *
 * @package    Kiwi
 * @subpackage filter
 * @author     Your name here
 */
abstract class BaseFoundationFormFilter extends BaseFormFilterPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'user_id'        => new sfWidgetFormPropelChoice(array('model' => 'User', 'add_empty' => true)),
      'logo'           => new sfWidgetFormFilterInput(),
      'content'        => new sfWidgetFormFilterInput(),
      'contact_person' => new sfWidgetFormFilterInput(),
      'sector_id'      => new sfWidgetFormPropelChoice(array('model' => 'Sector', 'add_empty' => true)),
      'latitude'       => new sfWidgetFormFilterInput(),
      'longitude'      => new sfWidgetFormFilterInput(),
      'address'        => new sfWidgetFormFilterInput(),
      'phone'          => new sfWidgetFormFilterInput(),
    ));

    $this->setValidators(array(
      'user_id'        => new sfValidatorPropelChoice(array('required' => false, 'model' => 'User', 'column' => 'id')),
      'logo'           => new sfValidatorPass(array('required' => false)),
      'content'        => new sfValidatorPass(array('required' => false)),
      'contact_person' => new sfValidatorPass(array('required' => false)),
      'sector_id'      => new sfValidatorPropelChoice(array('required' => false, 'model' => 'Sector', 'column' => 'id')),
      'latitude'       => new sfValidatorPass(array('required' => false)),
      'longitude'      => new sfValidatorPass(array('required' => false)),
      'address'        => new sfValidatorPass(array('required' => false)),
      'phone'          => new sfValidatorPass(array('required' => false)),
    ));

    $this->widgetSchema->setNameFormat('foundation_filters[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'Foundation';
  }

  public function getFields()
  {
    return array(
      'id'             => 'Number',
      'user_id'        => 'ForeignKey',
      'logo'           => 'Text',
      'content'        => 'Text',
      'contact_person' => 'Text',
      'sector_id'      => 'ForeignKey',
      'latitude'       => 'Text',
      'longitude'      => 'Text',
      'address'        => 'Text',
      'phone'          => 'Text',
    );
  }
}
