<?php

/**
 * FoundationImage filter form base class.
 *
 * @package    Kiwi
 * @subpackage filter
 * @author     Your name here
 */
abstract class BaseFoundationImageFormFilter extends BaseFormFilterPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'foundation_id' => new sfWidgetFormPropelChoice(array('model' => 'Foundation', 'add_empty' => true)),
      'project_id'    => new sfWidgetFormPropelChoice(array('model' => 'Projects', 'add_empty' => true)),
      'gallery_id'    => new sfWidgetFormPropelChoice(array('model' => 'Gallery', 'add_empty' => true)),
      'image'         => new sfWidgetFormFilterInput(array('with_empty' => false)),
      'logo_link'     => new sfWidgetFormFilterInput(),
      'is_logo'       => new sfWidgetFormChoice(array('choices' => array('' => 'yes or no', 1 => 'yes', 0 => 'no'))),
    ));

    $this->setValidators(array(
      'foundation_id' => new sfValidatorPropelChoice(array('required' => false, 'model' => 'Foundation', 'column' => 'id')),
      'project_id'    => new sfValidatorPropelChoice(array('required' => false, 'model' => 'Projects', 'column' => 'id')),
      'gallery_id'    => new sfValidatorPropelChoice(array('required' => false, 'model' => 'Gallery', 'column' => 'id')),
      'image'         => new sfValidatorPass(array('required' => false)),
      'logo_link'     => new sfValidatorPass(array('required' => false)),
      'is_logo'       => new sfValidatorChoice(array('required' => false, 'choices' => array('', 1, 0))),
    ));

    $this->widgetSchema->setNameFormat('foundation_image_filters[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'FoundationImage';
  }

  public function getFields()
  {
    return array(
      'id'            => 'Number',
      'foundation_id' => 'ForeignKey',
      'project_id'    => 'ForeignKey',
      'gallery_id'    => 'ForeignKey',
      'image'         => 'Text',
      'logo_link'     => 'Text',
      'is_logo'       => 'Boolean',
    );
  }
}
