<?php

/**
 * Meeting filter form base class.
 *
 * @package    Kiwi
 * @subpackage filter
 * @author     Your name here
 */
abstract class BaseMeetingFormFilter extends BaseFormFilterPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'is_closed'        => new sfWidgetFormChoice(array('choices' => array('' => 'yes or no', 1 => 'yes', 0 => 'no'))),
      'title'            => new sfWidgetFormFilterInput(array('with_empty' => false)),
      'starts_at'        => new sfWidgetFormFilterDate(array('from_date' => new sfWidgetFormDate(), 'to_date' => new sfWidgetFormDate(), 'with_empty' => false)),
      'places_available' => new sfWidgetFormFilterInput(array('with_empty' => false)),
      'places_taken'     => new sfWidgetFormFilterInput(),
    ));

    $this->setValidators(array(
      'is_closed'        => new sfValidatorChoice(array('required' => false, 'choices' => array('', 1, 0))),
      'title'            => new sfValidatorPass(array('required' => false)),
      'starts_at'        => new sfValidatorDateRange(array('required' => false, 'from_date' => new sfValidatorDate(array('required' => false)), 'to_date' => new sfValidatorDate(array('required' => false)))),
      'places_available' => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'places_taken'     => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
    ));

    $this->widgetSchema->setNameFormat('meeting_filters[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'Meeting';
  }

  public function getFields()
  {
    return array(
      'id'               => 'Number',
      'is_closed'        => 'Boolean',
      'title'            => 'Text',
      'starts_at'        => 'Date',
      'places_available' => 'Number',
      'places_taken'     => 'Number',
    );
  }
}
