<?php

/**
 * MeetingUser filter form base class.
 *
 * @package    Kiwi
 * @subpackage filter
 * @author     Your name here
 */
abstract class BaseMeetingUserFormFilter extends BaseFormFilterPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'meeting_id'  => new sfWidgetFormPropelChoice(array('model' => 'Meeting', 'add_empty' => true)),
      'activity_id' => new sfWidgetFormPropelChoice(array('model' => 'Activity', 'add_empty' => true)),
      'name'        => new sfWidgetFormFilterInput(array('with_empty' => false)),
      'email'       => new sfWidgetFormFilterInput(array('with_empty' => false)),
      'phone'       => new sfWidgetFormFilterInput(array('with_empty' => false)),
      'token'       => new sfWidgetFormFilterInput(array('with_empty' => false)),
      'status'      => new sfWidgetFormFilterInput(array('with_empty' => false)),
    ));

    $this->setValidators(array(
      'meeting_id'  => new sfValidatorPropelChoice(array('required' => false, 'model' => 'Meeting', 'column' => 'id')),
      'activity_id' => new sfValidatorPropelChoice(array('required' => false, 'model' => 'Activity', 'column' => 'id')),
      'name'        => new sfValidatorPass(array('required' => false)),
      'email'       => new sfValidatorPass(array('required' => false)),
      'phone'       => new sfValidatorPass(array('required' => false)),
      'token'       => new sfValidatorPass(array('required' => false)),
      'status'      => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
    ));

    $this->widgetSchema->setNameFormat('meeting_user_filters[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'MeetingUser';
  }

  public function getFields()
  {
    return array(
      'id'          => 'Number',
      'meeting_id'  => 'ForeignKey',
      'activity_id' => 'ForeignKey',
      'name'        => 'Text',
      'email'       => 'Text',
      'phone'       => 'Text',
      'token'       => 'Text',
      'status'      => 'Number',
    );
  }
}
