<?php

/**
 * MenuItem filter form base class.
 *
 * @package    Kiwi
 * @subpackage filter
 * @author     Your name here
 */
abstract class BaseMenuItemFormFilter extends BaseFormFilterPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'name'          => new sfWidgetFormFilterInput(array('with_empty' => false)),
      'link'          => new sfWidgetFormFilterInput(array('with_empty' => false)),
      'category_id'   => new sfWidgetFormPropelChoice(array('model' => 'MenuGroup', 'add_empty' => true)),
      'is_admin'      => new sfWidgetFormChoice(array('choices' => array('' => 'yes or no', 1 => 'yes', 0 => 'no'))),
      'is_not_logged' => new sfWidgetFormChoice(array('choices' => array('' => 'yes or no', 1 => 'yes', 0 => 'no'))),
      'is_volunteer'  => new sfWidgetFormChoice(array('choices' => array('' => 'yes or no', 1 => 'yes', 0 => 'no'))),
      'is_foundation' => new sfWidgetFormChoice(array('choices' => array('' => 'yes or no', 1 => 'yes', 0 => 'no'))),
      'position'      => new sfWidgetFormFilterInput(),
    ));

    $this->setValidators(array(
      'name'          => new sfValidatorPass(array('required' => false)),
      'link'          => new sfValidatorPass(array('required' => false)),
      'category_id'   => new sfValidatorPropelChoice(array('required' => false, 'model' => 'MenuGroup', 'column' => 'id')),
      'is_admin'      => new sfValidatorChoice(array('required' => false, 'choices' => array('', 1, 0))),
      'is_not_logged' => new sfValidatorChoice(array('required' => false, 'choices' => array('', 1, 0))),
      'is_volunteer'  => new sfValidatorChoice(array('required' => false, 'choices' => array('', 1, 0))),
      'is_foundation' => new sfValidatorChoice(array('required' => false, 'choices' => array('', 1, 0))),
      'position'      => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
    ));

    $this->widgetSchema->setNameFormat('menu_item_filters[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'MenuItem';
  }

  public function getFields()
  {
    return array(
      'id'            => 'Number',
      'name'          => 'Text',
      'link'          => 'Text',
      'category_id'   => 'ForeignKey',
      'is_admin'      => 'Boolean',
      'is_not_logged' => 'Boolean',
      'is_volunteer'  => 'Boolean',
      'is_foundation' => 'Boolean',
      'position'      => 'Number',
    );
  }
}
