<?php

/**
 * Rent filter form base class.
 *
 * @package    Kiwi
 * @subpackage filter
 * @author     Your name here
 */
abstract class BaseRentFormFilter extends BaseFormFilterPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'category_id'   => new sfWidgetFormPropelChoice(array('model' => 'RentCategory', 'add_empty' => true)),
      'title'         => new sfWidgetFormFilterInput(array('with_empty' => false)),
      'content'       => new sfWidgetFormFilterInput(array('with_empty' => false)),
      'conditions'    => new sfWidgetFormFilterInput(array('with_empty' => false)),
      'phone'         => new sfWidgetFormFilterInput(array('with_empty' => false)),
      'email'         => new sfWidgetFormFilterInput(array('with_empty' => false)),
      'adres'         => new sfWidgetFormFilterInput(array('with_empty' => false)),
      'quantity'      => new sfWidgetFormFilterInput(),
      'accepted'      => new sfWidgetFormChoice(array('choices' => array('' => 'yes or no', 1 => 'yes', 0 => 'no'))),
      'short_content' => new sfWidgetFormFilterInput(),
      'image1'        => new sfWidgetFormFilterInput(array('with_empty' => false)),
      'image2'        => new sfWidgetFormFilterInput(),
      'image3'        => new sfWidgetFormFilterInput(),
    ));

    $this->setValidators(array(
      'category_id'   => new sfValidatorPropelChoice(array('required' => false, 'model' => 'RentCategory', 'column' => 'id')),
      'title'         => new sfValidatorPass(array('required' => false)),
      'content'       => new sfValidatorPass(array('required' => false)),
      'conditions'    => new sfValidatorPass(array('required' => false)),
      'phone'         => new sfValidatorPass(array('required' => false)),
      'email'         => new sfValidatorPass(array('required' => false)),
      'adres'         => new sfValidatorPass(array('required' => false)),
      'quantity'      => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'accepted'      => new sfValidatorChoice(array('required' => false, 'choices' => array('', 1, 0))),
      'short_content' => new sfValidatorPass(array('required' => false)),
      'image1'        => new sfValidatorPass(array('required' => false)),
      'image2'        => new sfValidatorPass(array('required' => false)),
      'image3'        => new sfValidatorPass(array('required' => false)),
    ));

    $this->widgetSchema->setNameFormat('rent_filters[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'Rent';
  }

  public function getFields()
  {
    return array(
      'id'            => 'Number',
      'category_id'   => 'ForeignKey',
      'title'         => 'Text',
      'content'       => 'Text',
      'conditions'    => 'Text',
      'phone'         => 'Text',
      'email'         => 'Text',
      'adres'         => 'Text',
      'quantity'      => 'Number',
      'accepted'      => 'Boolean',
      'short_content' => 'Text',
      'image1'        => 'Text',
      'image2'        => 'Text',
      'image3'        => 'Text',
    );
  }
}
