<?php

/**
 * UserActivity filter form base class.
 *
 * @package    Kiwi
 * @subpackage filter
 * @author     Your name here
 */
abstract class BaseUserActivityFormFilter extends BaseFormFilterPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'status'           => new sfWidgetFormFilterInput(),
      'user_id'          => new sfWidgetFormPropelChoice(array('model' => 'User', 'add_empty' => true)),
      'activity_id'      => new sfWidgetFormPropelChoice(array('model' => 'Activity', 'add_empty' => true)),
      'comment'          => new sfWidgetFormFilterInput(array('with_empty' => false)),
      'application_date' => new sfWidgetFormFilterDate(array('from_date' => new sfWidgetFormDate(), 'to_date' => new sfWidgetFormDate())),
    ));

    $this->setValidators(array(
      'status'           => new sfValidatorSchemaFilter('text', new sfValidatorInteger(array('required' => false))),
      'user_id'          => new sfValidatorPropelChoice(array('required' => false, 'model' => 'User', 'column' => 'id')),
      'activity_id'      => new sfValidatorPropelChoice(array('required' => false, 'model' => 'Activity', 'column' => 'id')),
      'comment'          => new sfValidatorPass(array('required' => false)),
      'application_date' => new sfValidatorDateRange(array('required' => false, 'from_date' => new sfValidatorDate(array('required' => false)), 'to_date' => new sfValidatorDate(array('required' => false)))),
    ));

    $this->widgetSchema->setNameFormat('user_activity_filters[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'UserActivity';
  }

  public function getFields()
  {
    return array(
      'id'               => 'Number',
      'status'           => 'Number',
      'user_id'          => 'ForeignKey',
      'activity_id'      => 'ForeignKey',
      'comment'          => 'Text',
      'application_date' => 'Date',
    );
  }
}
