<?php

/**
 * Activity form.
 *
 * @package    Kiwi
 * @subpackage form
 * @author     Your name here
 */
class ActivityForm extends BaseActivityForm
{
  public function configure()
  {
  	
	$usr = sfContext::getInstance()->getUser();	
	$userObj = $usr->getUserObject();
    
	
	if(!$usr->isAuthenticated() || $usr->hasCredential("Organizacja")) {
    	$this->widgetSchema['user_id'] = new sfWidgetFormInputHidden();
    	$this->widgetSchema['archived'] = new sfWidgetFormInputHidden();
    	$this->widgetSchema['special'] = new sfWidgetFormInputHidden();
    	$this->widgetSchema['group_id'] = new sfWidgetFormInputHidden();
    	$this->widgetSchema['position'] = new sfWidgetFormInputHidden();
    	$this->widgetSchema['delete_at'] = new sfWidgetFormInputHidden();
	} else {
		$criteria = new Criteria();
		$criteria->add(UserTypePeer::NAME, "Organizacja", Criteria::LIKE);
		$type = UserTypePeer::doSelectOne($criteria);
		
		$criteria = new Criteria();
		$criteria->add(UserPeer::CATEGORY_ID, $type->getId(), Criteria::EQUAL);
		$criteria->addAscendingOrderByColumn(UserPeer::NAME);
		
		$this->widgetSchema['user_id'] = new sfWidgetFormPropelChoice(array('model' => 'User', 'add_empty' => false, 'criteria' => $criteria));
		
		
		$criteria = new Criteria();
		$criteria->add(GroupCategoryPeer::IS_GENERIC, false, Criteria::EQUAL);
		$criteria->addAscendingOrderByColumn(GroupCategoryPeer::NAME);
		
		$this->widgetSchema['group_id'] = new sfWidgetFormPropelChoice(array('model' => 'GroupCategory', 'add_empty' => true, 'criteria' => $criteria));
	}
    $this->widgetSchema['created_at'] = new sfWidgetFormInputHidden();
    $this->widgetSchema['address'] = new sfWidgetFormGMapAddress();
    $this->widgetSchema['latitude'] = new sfWidgetFormInputHidden(array(),  array("id" => "latitude"));
    $this->widgetSchema['longitude'] = new sfWidgetFormInputHidden(array(), array("id" => "longitude"));
    $this->widgetSchema['places_available'] = new sfWidgetFormInputText(array("default"=> 1));

    
   
	$this->validatorSchema->setOption('allow_extra_fields', true);
    $this->validatorSchema->setOption('filter_extra_fields', true);
    
    $this->validatorSchema['title']->setMessage("required", "Pole wymagane");
    $this->validatorSchema['content']->setMessage("required", "Pole wymagane");
    $this->validatorSchema['email']->setMessage("required", "Pole wymagane");
    $this->validatorSchema['contact_person']->setMessage("required", "Pole wymagane");
    $this->validatorSchema['phone']->setMessage("required", "Pole wymagane");
    
    $this->validatorSchema['phone'] = new sfValidatorRegex(
    			array('pattern' => "#\b[+]?[\\d-\\s]{9,20}\b#" ), 
    			array('invalid' => 'Wprowadź prawidłowy numer telefonu (np +48-58-1234567)')
    			);
    $this->validatorSchema['email'] = new sfValidatorEmail(
    			array( ), 
    			array('invalid' => 'Wprowadź prawidłowy e-mail'));
    $num = ActivityPeer::doCount(new Criteria());
    $this->validatorSchema['position'] = new sfValidatorNumber(array(
            		'max' => $num, 
            		'min' => 1),
    array('max' => "Pozycja nie może być większa od liczby ofert: ".$num,
            		'min' => "Pozycja musi być większa od 0")
    );
    
    
    $this->validatorSchema->setPostValidator(
  			new sfValidatorSchemaCompare(
  				'finishes_at', 
  				sfValidatorSchemaCompare::GREATER_THAN_EQUAL,
  				 'starts_at',
  				array("throw_global_error" => true),
  				array("invalid" => "Data początkowa wydarzenia musi być przed końcową."))
		);
    $this->validatorSchema['places_available'] = new sfValidatorNumber(array(
        		'max' => 1000, 
        		'min' => 1),
        		array('max' => "Zbyt duża ilość miejsc - wprowadź liczbę w przedziale 1-1000", 
        		'min' => "Zbyt mała ilość miejsc - wprowadź liczbę w przedziale 1-1000")
    );
    
	$usr = sfContext::getInstance()->getUser();	
	$userObj = $usr->getUserObject();
	
	if($usr->hasCredential("Organizacja")) {
    	$this->validatorSchema['user_id'] = new sfValidatorNumber(array(
    		'max' => $userObj->getId(), 
    		'min' => $userObj->getId())
    		);
	}
    
  }
}
