<?php

/**
 * Event form.
 *
 * @package    Kiwi
 * @subpackage form
 * @author     Your name here
 */
class EventForm extends BaseEventForm
{
  public function configure()
  {
  	
  	$this->widgetSchema['created_at'] = new sfWidgetFormInputHidden();
    $this->widgetSchema['project_id'] = new sfWidgetFormInputHidden();
    $this->widgetSchema['address'] = new sfWidgetFormGMapAddress();
    $this->widgetSchema['short_content'] = new sfWidgetFormInputText();
    $this->widgetSchema['is_calendar']= new sfWidgetFormChoice(array(
    	    	      'choices' => array(0=>'Nie',1=>'Tak'),
    	));
    
    $this->widgetSchema['latitude'] = new sfWidgetFormInputHidden(array(),  array("id" => "latitude"));
    $this->widgetSchema['longitude'] = new sfWidgetFormInputHidden(array(), array("id" => "longitude"));
    
    
    $this->validatorSchema['title']->setMessage("required", "Pole wymagane");
    $this->validatorSchema['content']->setMessage("required", "Pole wymagane");
    $this->validatorSchema['short_content'] = new sfValidatorString(
		    array('max_length' => 250,
		    	  'min_length' => 50
		    ),
		    array('max_length' => 'Zajawka za długa - powinna być długości od 50 do 250 znaków',
		    	 'min_length' => 'Zajawka za krótka - powinna być długości od 50 do 250 znaków', 
		    	 'required' => 'Zajawka za krótka - powinna być długości od 50 do 250 znaków'
   		 )
    );
    
   $this->widgetSchema['image'] = new sfWidgetFormInputFileEditable(array(
      'file_src'  => sfConfig::get('app_sever_name').sfConfig::get('app_event_images_path').$this->getObject()->getImage(),
      'is_image'  => true,
      'edit_mode' => !$this->isNew(),
      'template'  => '<div>%file%<br />%input%</div>',
    ));
    
  	$this->validatorSchema['image'] = new sfValidatorFile(array(
	  'required'   => $this->isNew(),
	  'path'       => sfConfig::get('app_event_images_path'),
	  'mime_types' => 'web_images',
  	  'max_size'   => sfConfig::get('app_max_picture_size')
	), array("mime_types" => "Nieprawidłowy format zdjęcia - %mime_type%", 
		"max_size" => "Zdjęcie za duże - maksymalna wielkość to %max_size% bajtów",
		"required" => "Wybierz zdjęcie"));
	
	$usr = sfContext::getInstance()->getUser();	
	$userObj = $usr->getUserObject();
	
	
	
    if($usr->hasCredential("Admin")) {
    	$this->widgetSchema['is_calendar']= new sfWidgetFormChoice(array(
    	    	    	      'choices' => array(0=>'Nie',1=>'Tak'),
    	));
    	$this->widgetSchema['is_published']= new sfWidgetFormChoice(array(
    	    	    	    	      'choices' => array(0=>'Nie',1=>'Tak'),
    	));
    	
    } else {
    	$this->widgetSchema['is_published'] = new sfWidgetFormInputHidden();
    }
    
    
    $this->validatorSchema->setPostValidator(
			    new sfValidatorSchemaCompare(
				    'finishes_at',
				    sfValidatorSchemaCompare::GREATER_THAN_EQUAL,
				    'starts_at',
			    	array("throw_global_error" => true),
			    	array("invalid" => "Data początkowa wydarzenia musi być przed końcową."))
	    	    );
    
    $this->validatorSchema->setOption('allow_extra_fields', true);
    $this->validatorSchema->setOption('filter_extra_fields', true);
  }
  
}
