<?php

/**
 * Foundation form.
 *
 * @package    Kiwi
 * @subpackage form
 * @author     Your name here
 */
class FoundationForm extends BaseFoundationForm
{
	


function setPath($path) {
	if (!$path || !file_exists(sfConfig::get('app_foundation_logo_path').$path)) {
		$path = 'no-photo.jpg';
	}
	$this->widgetSchema['logo']->setOption('file_src', sfConfig::get('app_sever_name').sfConfig::get('app_foundation_logo_path').$path);
}
	
public function configure() {
  	
	$this->widgetSchema['name'] = new sfWidgetFormInputText(array('label' => 'Nazwa'), array('size' => 80, 'MAXLENGTH' => 250));
	$this->widgetSchema['email'] = new sfWidgetFormInputText(array('label' => 'Email'));
	$this->widgetSchema['phone']->setOption('label', 'Telefon');
	$this->widgetSchema['www']->setOption('label', 'Strona www');
	$this->widgetSchema['content']->setAttributes(array('rows' => 10));
    $this->widgetSchema['content']->setOption("label", "Opis");
  	$this->widgetSchema['logo'] = new sfWidgetFormInputFileEditable(array(
		'label'     => 'Logo',
		'file_src'  => sfConfig::get('app_sever_name').sfConfig::get('app_foundation_logo_path'),
		'is_image'  => true,
		'template'  => '<div>%file%<br />%input%</div>',
    ));
	
	$this->widgetSchema['district_id']->setOption("label", "Dzielnica");
    $this->widgetSchema['address'] = new sfWidgetFormGMapAddress(array('label' => 'Adres'));
    $this->widgetSchema['latitude'] = new sfWidgetFormInputHidden(array(), array("id" => "latitude"));
    $this->widgetSchema['longitude'] = new sfWidgetFormInputHidden(array(), array("id" => "longitude"));
	
	$this->widgetSchema["area"] = new checkBoxWidget(array(
		'columnNumber' => 1,
		'choices' => Foundation::$areaLabels,
		'label' => ' '
	));
	
	$this->widgetSchema["rules"] = new checkBoxWidget(array(
		'columnNumber' => 1,
		'choices' => array('Akceptuję <a href="/kontakt/rules" target="_blank">regulamin</a> serwisu'),
		'label' => ' '
	));
	
    
    /*$this->widgetSchema['newImage'] = new sfWidgetFormInputFileEditable(array(
      'label'     => 'Nowe zdjęcie',
      'file_src'  => sfConfig::get('app_sever_name').sfConfig::get('app_foundation_gallery_path'),
      'is_image'  => true,
      'template'  => '<div>%input%</div>',
    ));*/
    
  /*  $this->widgetSchema['city_id'] = new sfWidgetFormPropelChoice(array('model' => 'City', 'add_empty' => true), array('id' => 'adminCity'));
    
    if($this->getObject()->getCity() != null) {
    	$city = $this->getObject()->getCity()->getId();
    	$criteria = new Criteria();
    	$criteria->add(DistrictPeer::CITY_ID, $city, Criteria::EQUAL);
    	$criteria->addAscendingOrderByColumn(DistrictPeer::NAME);
    	$this->widgetSchema['district_id'] = new sfWidgetFormPropelChoice(array('model' => 'District', 'add_empty' => true, 'criteria' => $criteria), array('id' => 'adminDistrict'));
    }
    else $this->widgetSchema['district_id'] = new sfWidgetFormChoice(array(
    													  'choices'  => array(),
    													  'multiple' => false,
    													  'expanded' => false,
    											     	  'label'    => 'Dzielnica'
    ), array('id' => 'adminDistrict'));
*/    
	 
	//$this->widgetSchema["rules"] = new sfWidgetFormInputCheckbox(array("label" => 'Akceptuję <a href="/kontakt/rules">regulamin</a> serwisu'));
	 

	$this->setValidators(array(
		
     'name' => new sfValidatorString(
    			array('max_length' => 250, 
    				  'min_length' => 3
    				  ), 
    			array('max_length' => 'Za długa nazwa- wprowadź nazwę zawierającą od 3 do 250 znaków', 
    				  'min_length' => 'Za krótka nazwa - wprowadź nazwę zawierającą od 3 do 250 znaków',
					  'required' => 'Brak nazwy'
    				 )
    			),
		
	'email' => new sfEmailValidatorExtended(
				array('userId' => 0),
				array("exists" => "Użytkownik o takim adresie email już istnieje",
					  'required' => 'Brak adresu email'
					 )
				),
		
    'phone' => new sfValidatorRegex(
    			array('pattern' => "#\b[+]?[\\d-\\s]{9,20}\b#" ), 
    			array('invalid' => 'Wprowadź prawidłowy numer telefonu (np. +48581234567)',
    				'required' => 'Wprowadź prawidłowy numer telefonu (np. +48581234567)')
    			),
		
	'address' => new sfValidatorString(array('required' => true), array('required' => 'Brak adresu')),
	'latitude' => new sfValidatorString(array('required' => true), array('required' => 'Wyszukaj adres na mapie')),
	'longitude' => new sfValidatorString(array('required' => true), array('required' => 'Wyszukaj adres na mapie')),
		
	'content' => new sfValidatorString(
    			array('required' => true,
					  'min_length' => 200
					 ), 
    			array('min_length' => 'Opis musi się składać z minimum 200 znaków',
					  'required' => 'Brak opisu'
					 )
    			),
		
    'logo' => new sfValidatorFile(
    			array('required'   => true,
					  'path'       => sfConfig::get('app_foundation_logo_path'),
					  'mime_types' => 'web_images',
				  	  'max_size'   => sfConfig::get('app_max_picture_size')
					), 
				array("required" => "Brak logo",
					  "mime_types" => "Nieprawidłowy format zdjęcia - %mime_type%", 
					  "max_size" => "Zdjęcie za duże - maksymalna wielkość to %max_size% bajtów"
					)
				),
		
	'area' => new sfValidatorChoice(
			array(
				'choices' => array_keys(array(0,1,2,3,4,5,6)),
				'multiple' => true
			),
			array('required' => 'Nie określono obszarów działalności')),
		
	'rules' => new sfValidatorChoice(
			array(
				'choices' => array_keys(array(0)),
				'multiple' => true
			),
			array('required' => 'Musisz zaakceptować regulamin'))
		
    ));
	
	
	$this->widgetSchema->setNameFormat('%s');
	
	$this->validatorSchema->setOption('allow_extra_fields', true);
    $this->validatorSchema->setOption('filter_extra_fields', false);
    
  }
}
