<?php

/**
 * Rent form.
 *
 * @package    Kiwi
 * @subpackage form
 * @author     Your name here
 */
class RentForm extends BaseRentForm
{
  public function configure()
  {
  	if(isset($_GET['rentcat']) && $_GET['rentcat'] == 1) $cat = "Baza szkoleniowców";
  	else if(isset($_GET['rentcat']) && $_GET['rentcat'] == 2) $cat = 'Baza sprzętu';
  	else $cat = 'Baza pomieszczeń';
  	
  	$criteria = new Criteria();
  	$criteria->add(RentCategoryPeer::CATEGORY_ID, $cat, Criteria::LIKE);
  	$criteria->addAscendingOrderByColumn(RentCategoryPeer::NAME);
  	
  	$this->widgetSchema['category_id'] = new sfWidgetFormPropelChoice(array('model' => 'RentCategory', 'add_empty' => false, 'criteria' => $criteria));
  	
  	$usr = sfContext::getInstance()->getUser();
  	$userObj = $usr->getUserObject();
  	
  	if(!$usr->hasCredential("Admin")) {
  		$this->widgetSchema['accepted'] = new sfWidgetFormInputHidden();
  	}
  	
  	
  	$this->widgetSchema['image1'] = new sfWidgetFormInputFileEditable(array(
  	      'file_src'  => sfConfig::get('app_sever_name').sfConfig::get('app_rent_images_path').$this->getObject()->getImage1(),
  	      'is_image'  => true,
  	      'edit_mode' => !$this->isNew(),
  		  'label' => 'Zdjęcie',
  	      'template'  => '<div>%file%<br />%input%</div>',
  	));
  	
  	$this->validatorSchema['image1'] = new sfValidatorFile(array(
  		  'required'   => $this->isNew(),
  		  'path'       => sfConfig::get('app_rent_images_path'),
  		  'mime_types' => 'web_images',
  	  	  'max_size'   => sfConfig::get('app_max_picture_size')
  	), array("mime_types" => "Nieprawidłowy format zdjęcia - %mime_type%",
  			"max_size" => "Zdjęcie za duże - maksymalna wielkość to %max_size% bajtów",
  			"required" => "Wybierz zdjęcie"));
  	
  	$this->widgetSchema['image2'] = new sfWidgetFormInputFileEditable(array(
  	      'file_src'  => sfConfig::get('app_sever_name').sfConfig::get('app_rent_images_path').$this->getObject()->getImage2(),
  	      'is_image'  => true,
  	      'edit_mode' => !$this->isNew(),
  		  'label' => 'Zdjęcie',
  	      'template'  => '<div>%file%<br />%input%</div>',
  	));
  	
  	$this->validatorSchema['image2'] = new sfValidatorFile(array(
  		  'required'   => false,
  		  'path'       => sfConfig::get('app_rent_images_path'),
  		  'mime_types' => 'web_images',
  	  	  'max_size'   => sfConfig::get('app_max_picture_size')
  	), array("mime_types" => "Nieprawidłowy format zdjęcia - %mime_type%",
  			"max_size" => "Zdjęcie za duże - maksymalna wielkość to %max_size% bajtów",
  			"required" => "Wybierz zdjęcie"));
  	
  	
  	$this->widgetSchema['image3'] = new sfWidgetFormInputFileEditable(array(
  	  	      'file_src'  => sfConfig::get('app_sever_name').sfConfig::get('app_rent_images_path').$this->getObject()->getImage3(),
  	  	      'is_image'  => true,
  	  	      'edit_mode' => !$this->isNew(),
  	  		  'label' => 'Zdjęcie',
  	  	      'template'  => '<div>%file%<br />%input%</div>',
  	));
  	 
  	$this->validatorSchema['image3'] = new sfValidatorFile(array(
  	  		  'required'   => false,
  	  		  'path'       => sfConfig::get('app_rent_images_path'),
  	  		  'mime_types' => 'web_images',
  	  	  	  'max_size'   => sfConfig::get('app_max_picture_size')
  	), array("mime_types" => "Nieprawidłowy format zdjęcia - %mime_type%",
  	  			"max_size" => "Zdjęcie za duże - maksymalna wielkość to %max_size% bajtów",
  	  			"required" => "Wybierz zdjęcie"));
  	
  	
  	$this->validatorSchema["email"] = new sfValidatorEmail(array(), array("invalid" => "Nieprawidłowy email"));
  	
  }
}
