<?php

/**
 * Volunteer form.
 *
 * @package    Kiwi
 * @subpackage form
 * @author     Your name here
 */
class VolunteerForm extends BaseVolunteerForm
{
	function setPath($path) {

		if (!$path || !file_exists(sfConfig::get('app_volunteer_images_path').$path)) {
			$path = 'no-photo.jpg';
		}
		$this->widgetSchema['photo']->setOption('file_src', sfConfig::get('app_sever_name').sfConfig::get('app_volunteer_images_path').$path);
	}
	
  public function configure()
  {
  	$this->widgetSchema['photo'] = new sfWidgetFormInputFileEditable(array(
      'label'     => 'Zdjęcie',
      'file_src'  => sfConfig::get('app_sever_name').sfConfig::get('app_volunteer_images_path'),
      'is_image'  => true,
      'template'  => '<div>%file%<br />%input%</div>',
    ), array("class" => "kiwiFileInput"));
    
    $textInputs = array(
    	"first_name" => "Imię",
    	"last_name" => "Nazwisko",
    	"other_languages" => "Inne języki",
    	"other_skills" => "Inne umiejętności",
    	"phone" => "Telefon"
    );
    
    formHelper::setTextInputs($this, $textInputs);
    
    $this->widgetSchema['education'] = new sfWidgetFormChoice(array(
		  'choices'  => Volunteer::$educationLabels,
		  'multiple' => false,
		  'expanded' => false,
		  'label'	=> "Edukacja"
		));
	
	$this->widgetSchema['is_male'] = new sfWidgetFormChoice(array(
		  'choices'  => Volunteer::$sexLabels,
		  'multiple' => false,
		  'expanded' => false,
		  'label'	=> "Płeć"
		));
		
	$this->widgetSchema['prof_status'] = new sfWidgetFormChoice(array(
		  'choices'  => Volunteer::$profStatusLabels,
		  'multiple' => false,
		  'expanded' => false,
		  'label'	=> "Sytuacja zawodowa"
		));
	$ageLabels = array();
	
	for($i = 1940; $i < 2012; $i++) $ageLabels[$i] = $i;
	
	$this->widgetSchema['age'] = new sfWidgetFormChoice(array(
		  'choices'  => $ageLabels,
		  'multiple' => false,
		  'expanded' => false,
		  'label' => 'Rok urodzenia'
		));
	
		$this->widgetSchema["hobby"] = new checkBoxWidget(array(
		  'columnNumber' => 3,
		  'choices' => Volunteer::$hobbyLabels,
		  'label' => ' '
		));
		$this->widgetSchema["skill"] = new checkBoxWidget(array(
		  'columnNumber' => 3,
		  'choices' => Volunteer::$skillLabels,
		  'label' => ' '
		));
		$this->widgetSchema["language"] = new checkBoxWidget(array(
		  'columnNumber' => 3,
		  'choices' => Volunteer::$languageLabels,
		  'label' => ' '
		));	
	//$this->widgetSchema["newsletter"] = new sfWidgetFormInputCheckbox(array("label" => "Czy chcesz otrzymywać newslettera o nowych ofertach?"));
	$this->widgetSchema["newsletter"] = new checkBoxWidget(array(
		  'columnNumber' => 3,
		  'choices' => array('chcę otrzymywać newslettera o nowych ofertach'),
		  'label' => ' '
		));
	$this->widgetSchema["rules"] = new sfWidgetFormInputCheckbox(array("label" => "Akceptuję regulamin serwisu"));
	
	$activities = ActivityTypePeer::doSelect( new Criteria() );
	$aa = array();
	
	foreach($activities as $activity)
		$aa[$activity->getId()] = $activity->getName();
	
	$this->widgetSchema['content']->setOption("label", "O sobie");
	$this->setValidators(array(
     'first_name' => new sfValidatorString(
    			array(  'min_length' => 1), 
    			array('min_length' => 'Wprowadź swoje imię', 
    				'required' => 'Wprowadź swoje imię')
    			),
     'last_name' => new sfValidatorString(
    			array(  'min_length' => 1 ), 
    			array('min_length' => 'Wprowadź swoje nazwisko', 
    				'required' => 'Wprowadź swoje nazwisko')
    			),
    'phone' => new sfValidatorRegex(
    			array('pattern' => "#\b[+]?\\d{9,11}\b#" ), 
    			array('invalid' => 'Wprowadź prawidłowy numer telefonu (np +48-581234567)',
    			'required' => 'Wprowadź  numer telefonu (np +48-581234567)')
    			),
   	 'photo' => new sfValidatorFile(
    			array('required'   => false,
					  'path'       => sfConfig::get('app_volunteer_images_path'),
					  'mime_types' => 'web_images',
				  	  'max_size'   => sfConfig::get('app_max_picture_size')
					), 
				array("mime_types" => "Nieprawidłowy format zdjęcia - %mime_type%", 
					  "max_size" => "Zdjęcie za duże - maksymalna wielkość to %max_size% bajtów"
					)
				)/*,
	  'rules' => new sfValidatorString(
    			array('min_length' => 2 ), 
    			array(
    			'min_length' => 'Musisz zaakceptować zasady portalu',
    			'required' => 'Musisz zaakceptować zasady portalu')
    			)*/
    ));
	$this->widgetSchema->setNameFormat('%s');
	
	$this->validatorSchema->setOption('allow_extra_fields', true);
    $this->validatorSchema->setOption('filter_extra_fields', false);
    
  }
}
