<?php

/**
 * VolunteersAction form.
 *
 * @package    Kiwi
 * @subpackage form
 * @author     Your name here
 */
class VolunteersActionForm extends BaseVolunteersActionForm
{
  public function configure()
  {
  	$this->widgetSchema['created_at'] = new sfWidgetFormInputHidden();
  	
  	$this->validatorSchema['title']->setMessage("required", "Pole wymagane");
  	$this->validatorSchema['content']->setMessage("required", "Pole wymagane");
  	$this->validatorSchema['short_content'] = new sfValidatorString(
  	array('max_length' => 250,
  			    	  'min_length' => 50
  	),
  	array('max_length' => 'Zajawka za długa - powinna być długości od 50 do 250 znaków',
  			    	 'min_length' => 'Zajawka za krótka - powinna być długości od 50 do 250 znaków', 
  			    	 'required' => 'Zajawka za krótka - powinna być długości od 50 do 250 znaków'
  	)
  	);
  	
  	$this->widgetSchema['image'] = new sfWidgetFormInputFileEditable(array(
  	      'file_src'  => sfConfig::get('app_sever_name').sfConfig::get('app_event_images_path').$this->getObject()->getImage(),
  	      'is_image'  => true,
  	      'edit_mode' => !$this->isNew(),
  	      'template'  => '<div>%file%<br />%input%</div>',
  	));
  	
  	$this->validatorSchema['image'] = new sfValidatorFile(array(
  		  'required'   => $this->isNew(),
  		  'path'       => sfConfig::get('app_event_images_path'),
  		  'mime_types' => 'web_images',
  	  	  'max_size'   => sfConfig::get('app_max_picture_size')
  	), array("mime_types" => "Nieprawidłowy format zdjęcia - %mime_type%",
  			"max_size" => "Zdjęcie za duże - maksymalna wielkość to %max_size% bajtów",
  			"required" => "Wybierz zdjęcie"));
  	
  	
  	
  	$this->validatorSchema->setOption('allow_extra_fields', true);
  	$this->validatorSchema->setOption('filter_extra_fields', true);
  }
}
