<?php

/**
 * Activity form base class.
 *
 * @method Activity getObject() Returns the current form's model object
 *
 * @package    Kiwi
 * @subpackage form
 * @author     Your name here
 */
abstract class BaseActivityForm extends BaseFormPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'id'               => new sfWidgetFormInputHidden(),
      'title'            => new sfWidgetFormInputText(),
      'content'          => new sfWidgetFormTextarea(),
      'is_constant'      => new sfWidgetFormInputCheckbox(),
      'is_internet'      => new sfWidgetFormInputCheckbox(),
      'is_sent'          => new sfWidgetFormInputCheckbox(),
      'starts_at'        => new sfWidgetFormDate(),
      'finishes_at'      => new sfWidgetFormDate(),
      'created_at'       => new sfWidgetFormDateTime(),
      'delete_at'        => new sfWidgetFormDate(),
      'places_available' => new sfWidgetFormInputText(),
      'user_id'          => new sfWidgetFormPropelChoice(array('model' => 'User', 'add_empty' => false)),
      'group_id'         => new sfWidgetFormPropelChoice(array('model' => 'GroupCategory', 'add_empty' => true)),
      'contact_person'   => new sfWidgetFormInputText(),
      'email'            => new sfWidgetFormInputText(),
      'phone'            => new sfWidgetFormInputText(),
      'latitude'         => new sfWidgetFormInputText(),
      'longitude'        => new sfWidgetFormInputText(),
      'address'          => new sfWidgetFormInputText(),
      'archived'         => new sfWidgetFormInputCheckbox(),
      'special'          => new sfWidgetFormInputCheckbox(),
      'position'         => new sfWidgetFormInputText(),
    ));

    $this->setValidators(array(
      'id'               => new sfValidatorChoice(array('choices' => array($this->getObject()->getId()), 'empty_value' => $this->getObject()->getId(), 'required' => false)),
      'title'            => new sfValidatorString(array('max_length' => 255)),
      'content'          => new sfValidatorString(),
      'is_constant'      => new sfValidatorBoolean(array('required' => false)),
      'is_internet'      => new sfValidatorBoolean(array('required' => false)),
      'is_sent'          => new sfValidatorBoolean(array('required' => false)),
      'starts_at'        => new sfValidatorDate(array('required' => false)),
      'finishes_at'      => new sfValidatorDate(array('required' => false)),
      'created_at'       => new sfValidatorDateTime(),
      'delete_at'        => new sfValidatorDate(array('required' => false)),
      'places_available' => new sfValidatorInteger(array('min' => -2147483648, 'max' => 2147483647, 'required' => false)),
      'user_id'          => new sfValidatorPropelChoice(array('model' => 'User', 'column' => 'id')),
      'group_id'         => new sfValidatorPropelChoice(array('model' => 'GroupCategory', 'column' => 'id', 'required' => false)),
      'contact_person'   => new sfValidatorString(array('max_length' => 255)),
      'email'            => new sfValidatorString(array('max_length' => 255)),
      'phone'            => new sfValidatorString(array('max_length' => 255)),
      'latitude'         => new sfValidatorString(array('max_length' => 25, 'required' => false)),
      'longitude'        => new sfValidatorString(array('max_length' => 25, 'required' => false)),
      'address'          => new sfValidatorString(array('max_length' => 255, 'required' => false)),
      'archived'         => new sfValidatorBoolean(array('required' => false)),
      'special'          => new sfValidatorBoolean(array('required' => false)),
      'position'         => new sfValidatorInteger(array('min' => -2147483648, 'max' => 2147483647, 'required' => false)),
    ));

    $this->widgetSchema->setNameFormat('activity[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'Activity';
  }


}
