<?php

/**
 * Event form base class.
 *
 * @method Event getObject() Returns the current form's model object
 *
 * @package    Kiwi
 * @subpackage form
 * @author     Your name here
 */
abstract class BaseEventForm extends BaseFormPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'id'            => new sfWidgetFormInputHidden(),
      'is_calendar'   => new sfWidgetFormInputCheckbox(),
      'is_published'  => new sfWidgetFormInputCheckbox(),
      'title'         => new sfWidgetFormInputText(),
      'latitude'      => new sfWidgetFormInputText(),
      'longitude'     => new sfWidgetFormInputText(),
      'address'       => new sfWidgetFormInputText(),
      'content'       => new sfWidgetFormTextarea(),
      'short_content' => new sfWidgetFormTextarea(),
      'starts_at'     => new sfWidgetFormDate(),
      'finishes_at'   => new sfWidgetFormDate(),
      'created_at'    => new sfWidgetFormDateTime(),
      'image'         => new sfWidgetFormInputText(),
      'category_id'   => new sfWidgetFormPropelChoice(array('model' => 'NewsCategory', 'add_empty' => true)),
      'project_id'    => new sfWidgetFormPropelChoice(array('model' => 'Projects', 'add_empty' => true)),
    ));

    $this->setValidators(array(
      'id'            => new sfValidatorChoice(array('choices' => array($this->getObject()->getId()), 'empty_value' => $this->getObject()->getId(), 'required' => false)),
      'is_calendar'   => new sfValidatorBoolean(array('required' => false)),
      'is_published'  => new sfValidatorBoolean(array('required' => false)),
      'title'         => new sfValidatorString(array('max_length' => 255)),
      'latitude'      => new sfValidatorString(array('max_length' => 25, 'required' => false)),
      'longitude'     => new sfValidatorString(array('max_length' => 25, 'required' => false)),
      'address'       => new sfValidatorString(array('max_length' => 255, 'required' => false)),
      'content'       => new sfValidatorString(),
      'short_content' => new sfValidatorString(array('required' => false)),
      'starts_at'     => new sfValidatorDate(array('required' => false)),
      'finishes_at'   => new sfValidatorDate(array('required' => false)),
      'created_at'    => new sfValidatorDateTime(),
      'image'         => new sfValidatorString(array('max_length' => 255, 'required' => false)),
      'category_id'   => new sfValidatorPropelChoice(array('model' => 'NewsCategory', 'column' => 'id', 'required' => false)),
      'project_id'    => new sfValidatorPropelChoice(array('model' => 'Projects', 'column' => 'id', 'required' => false)),
    ));

    $this->widgetSchema->setNameFormat('event[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'Event';
  }


}
