<?php

/**
 * Foundation form base class.
 *
 * @method Foundation getObject() Returns the current form's model object
 *
 * @package    Kiwi
 * @subpackage form
 * @author     Your name here
 */
abstract class BaseFoundationForm extends BaseFormPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'id'             => new sfWidgetFormInputHidden(),
      'user_id'        => new sfWidgetFormPropelChoice(array('model' => 'User', 'add_empty' => false)),
      'logo'           => new sfWidgetFormInputText(),
      'content'        => new sfWidgetFormTextarea(),
      'contact_person' => new sfWidgetFormInputText(),
      'latitude'       => new sfWidgetFormInputText(),
      'longitude'      => new sfWidgetFormInputText(),
      'address'        => new sfWidgetFormInputText(),
      'district_id'    => new sfWidgetFormPropelChoice(array('model' => 'District', 'add_empty' => false)),
      'phone'          => new sfWidgetFormInputText(),
      'www'            => new sfWidgetFormInputText(),
      'area0'          => new sfWidgetFormInputCheckbox(),
      'area1'          => new sfWidgetFormInputCheckbox(),
      'area2'          => new sfWidgetFormInputCheckbox(),
      'area3'          => new sfWidgetFormInputCheckbox(),
      'area4'          => new sfWidgetFormInputCheckbox(),
      'area5'          => new sfWidgetFormInputCheckbox(),
      'area6'          => new sfWidgetFormInputCheckbox(),
      'active'         => new sfWidgetFormInputCheckbox(),
    ));

    $this->setValidators(array(
      'id'             => new sfValidatorChoice(array('choices' => array($this->getObject()->getId()), 'empty_value' => $this->getObject()->getId(), 'required' => false)),
      'user_id'        => new sfValidatorPropelChoice(array('model' => 'User', 'column' => 'id')),
      'logo'           => new sfValidatorString(array('max_length' => 255, 'required' => false)),
      'content'        => new sfValidatorString(array('required' => false)),
      'contact_person' => new sfValidatorString(array('max_length' => 255, 'required' => false)),
      'latitude'       => new sfValidatorString(array('max_length' => 25, 'required' => false)),
      'longitude'      => new sfValidatorString(array('max_length' => 25, 'required' => false)),
      'address'        => new sfValidatorString(array('max_length' => 255, 'required' => false)),
      'district_id'    => new sfValidatorPropelChoice(array('model' => 'District', 'column' => 'id')),
      'phone'          => new sfValidatorString(array('max_length' => 255, 'required' => false)),
      'www'            => new sfValidatorString(array('max_length' => 255, 'required' => false)),
      'area0'          => new sfValidatorBoolean(array('required' => false)),
      'area1'          => new sfValidatorBoolean(array('required' => false)),
      'area2'          => new sfValidatorBoolean(array('required' => false)),
      'area3'          => new sfValidatorBoolean(array('required' => false)),
      'area4'          => new sfValidatorBoolean(array('required' => false)),
      'area5'          => new sfValidatorBoolean(array('required' => false)),
      'area6'          => new sfValidatorBoolean(array('required' => false)),
      'active'         => new sfValidatorBoolean(),
    ));

    $this->widgetSchema->setNameFormat('foundation[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'Foundation';
  }


}
