<?php

/**
 * FoundationImage form base class.
 *
 * @method FoundationImage getObject() Returns the current form's model object
 *
 * @package    Kiwi
 * @subpackage form
 * @author     Your name here
 */
abstract class BaseFoundationImageForm extends BaseFormPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'id'            => new sfWidgetFormInputHidden(),
      'foundation_id' => new sfWidgetFormPropelChoice(array('model' => 'Foundation', 'add_empty' => true)),
      'project_id'    => new sfWidgetFormPropelChoice(array('model' => 'Projects', 'add_empty' => true)),
      'gallery_id'    => new sfWidgetFormPropelChoice(array('model' => 'Gallery', 'add_empty' => true)),
      'image'         => new sfWidgetFormInputText(),
      'logo_link'     => new sfWidgetFormInputText(),
      'is_logo'       => new sfWidgetFormInputCheckbox(),
    ));

    $this->setValidators(array(
      'id'            => new sfValidatorChoice(array('choices' => array($this->getObject()->getId()), 'empty_value' => $this->getObject()->getId(), 'required' => false)),
      'foundation_id' => new sfValidatorPropelChoice(array('model' => 'Foundation', 'column' => 'id', 'required' => false)),
      'project_id'    => new sfValidatorPropelChoice(array('model' => 'Projects', 'column' => 'id', 'required' => false)),
      'gallery_id'    => new sfValidatorPropelChoice(array('model' => 'Gallery', 'column' => 'id', 'required' => false)),
      'image'         => new sfValidatorString(array('max_length' => 255)),
      'logo_link'     => new sfValidatorString(array('max_length' => 255, 'required' => false)),
      'is_logo'       => new sfValidatorBoolean(array('required' => false)),
    ));

    $this->widgetSchema->setNameFormat('foundation_image[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'FoundationImage';
  }


}
