<?php

/**
 * Meeting form base class.
 *
 * @method Meeting getObject() Returns the current form's model object
 *
 * @package    Kiwi
 * @subpackage form
 * @author     Your name here
 */
abstract class BaseMeetingForm extends BaseFormPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'id'               => new sfWidgetFormInputHidden(),
      'is_closed'        => new sfWidgetFormInputCheckbox(),
      'title'            => new sfWidgetFormInputText(),
      'starts_at'        => new sfWidgetFormDateTime(),
      'places_available' => new sfWidgetFormInputText(),
      'places_taken'     => new sfWidgetFormInputText(),
    ));

    $this->setValidators(array(
      'id'               => new sfValidatorChoice(array('choices' => array($this->getObject()->getId()), 'empty_value' => $this->getObject()->getId(), 'required' => false)),
      'is_closed'        => new sfValidatorBoolean(array('required' => false)),
      'title'            => new sfValidatorString(array('max_length' => 255)),
      'starts_at'        => new sfValidatorDateTime(),
      'places_available' => new sfValidatorInteger(array('min' => -2147483648, 'max' => 2147483647)),
      'places_taken'     => new sfValidatorInteger(array('min' => -2147483648, 'max' => 2147483647, 'required' => false)),
    ));

    $this->widgetSchema->setNameFormat('meeting[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'Meeting';
  }


}
