<?php

/**
 * MenuItem form base class.
 *
 * @method MenuItem getObject() Returns the current form's model object
 *
 * @package    Kiwi
 * @subpackage form
 * @author     Your name here
 */
abstract class BaseMenuItemForm extends BaseFormPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'id'            => new sfWidgetFormInputHidden(),
      'name'          => new sfWidgetFormInputText(),
      'link'          => new sfWidgetFormInputText(),
      'category_id'   => new sfWidgetFormPropelChoice(array('model' => 'MenuGroup', 'add_empty' => false)),
      'is_admin'      => new sfWidgetFormInputCheckbox(),
      'is_not_logged' => new sfWidgetFormInputCheckbox(),
      'is_volunteer'  => new sfWidgetFormInputCheckbox(),
      'is_foundation' => new sfWidgetFormInputCheckbox(),
      'position'      => new sfWidgetFormInputText(),
    ));

    $this->setValidators(array(
      'id'            => new sfValidatorChoice(array('choices' => array($this->getObject()->getId()), 'empty_value' => $this->getObject()->getId(), 'required' => false)),
      'name'          => new sfValidatorString(array('max_length' => 255)),
      'link'          => new sfValidatorString(array('max_length' => 255)),
      'category_id'   => new sfValidatorPropelChoice(array('model' => 'MenuGroup', 'column' => 'id')),
      'is_admin'      => new sfValidatorBoolean(array('required' => false)),
      'is_not_logged' => new sfValidatorBoolean(array('required' => false)),
      'is_volunteer'  => new sfValidatorBoolean(array('required' => false)),
      'is_foundation' => new sfValidatorBoolean(array('required' => false)),
      'position'      => new sfValidatorInteger(array('min' => -2147483648, 'max' => 2147483647, 'required' => false)),
    ));

    $this->validatorSchema->setPostValidator(
      new sfValidatorPropelUnique(array('model' => 'MenuItem', 'column' => array('name')))
    );

    $this->widgetSchema->setNameFormat('menu_item[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'MenuItem';
  }


}
