<?php

/**
 * News form base class.
 *
 * @method News getObject() Returns the current form's model object
 *
 * @package    Kiwi
 * @subpackage form
 * @author     Your name here
 */
abstract class BaseNewsForm extends BaseFormPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'id'            => new sfWidgetFormInputHidden(),
      'category_id'   => new sfWidgetFormPropelChoice(array('model' => 'NewsCategory', 'add_empty' => false)),
      'title'         => new sfWidgetFormInputText(),
      'content'       => new sfWidgetFormTextarea(),
      'short_content' => new sfWidgetFormTextarea(),
      'image'         => new sfWidgetFormInputText(),
      'created_at'    => new sfWidgetFormDate(),
    ));

    $this->setValidators(array(
      'id'            => new sfValidatorChoice(array('choices' => array($this->getObject()->getId()), 'empty_value' => $this->getObject()->getId(), 'required' => false)),
      'category_id'   => new sfValidatorPropelChoice(array('model' => 'NewsCategory', 'column' => 'id')),
      'title'         => new sfValidatorString(array('max_length' => 255)),
      'content'       => new sfValidatorString(),
      'short_content' => new sfValidatorString(array('required' => false)),
      'image'         => new sfValidatorString(array('max_length' => 255)),
      'created_at'    => new sfValidatorDate(),
    ));

    $this->widgetSchema->setNameFormat('news[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'News';
  }


}
