<?php

/**
 * Patronage form base class.
 *
 * @method Patronage getObject() Returns the current form's model object
 *
 * @package    Kiwi
 * @subpackage form
 * @author     Your name here
 */
abstract class BasePatronageForm extends BaseFormPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'id'            => new sfWidgetFormInputHidden(),
      'name'          => new sfWidgetFormInputText(),
      'content'       => new sfWidgetFormTextarea(),
      'short_content' => new sfWidgetFormTextarea(),
      'created_at'    => new sfWidgetFormDateTime(),
      'event_date'    => new sfWidgetFormDateTime(),
      'image'         => new sfWidgetFormInputText(),
    ));

    $this->setValidators(array(
      'id'            => new sfValidatorChoice(array('choices' => array($this->getObject()->getId()), 'empty_value' => $this->getObject()->getId(), 'required' => false)),
      'name'          => new sfValidatorString(array('max_length' => 255)),
      'content'       => new sfValidatorString(),
      'short_content' => new sfValidatorString(array('required' => false)),
      'created_at'    => new sfValidatorDateTime(),
      'event_date'    => new sfValidatorDateTime(),
      'image'         => new sfValidatorString(array('max_length' => 255)),
    ));

    $this->widgetSchema->setNameFormat('patronage[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'Patronage';
  }


}
