<?php

/**
 * Rent form base class.
 *
 * @method Rent getObject() Returns the current form's model object
 *
 * @package    Kiwi
 * @subpackage form
 * @author     Your name here
 */
abstract class BaseRentForm extends BaseFormPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'id'            => new sfWidgetFormInputHidden(),
      'category_id'   => new sfWidgetFormPropelChoice(array('model' => 'RentCategory', 'add_empty' => false)),
      'title'         => new sfWidgetFormInputText(),
      'content'       => new sfWidgetFormTextarea(),
      'conditions'    => new sfWidgetFormTextarea(),
      'phone'         => new sfWidgetFormInputText(),
      'email'         => new sfWidgetFormInputText(),
      'adres'         => new sfWidgetFormInputText(),
      'quantity'      => new sfWidgetFormInputText(),
      'accepted'      => new sfWidgetFormInputCheckbox(),
      'short_content' => new sfWidgetFormTextarea(),
      'image1'        => new sfWidgetFormInputText(),
      'image2'        => new sfWidgetFormInputText(),
      'image3'        => new sfWidgetFormInputText(),
    ));

    $this->setValidators(array(
      'id'            => new sfValidatorChoice(array('choices' => array($this->getObject()->getId()), 'empty_value' => $this->getObject()->getId(), 'required' => false)),
      'category_id'   => new sfValidatorPropelChoice(array('model' => 'RentCategory', 'column' => 'id')),
      'title'         => new sfValidatorString(array('max_length' => 255)),
      'content'       => new sfValidatorString(),
      'conditions'    => new sfValidatorString(),
      'phone'         => new sfValidatorString(array('max_length' => 255)),
      'email'         => new sfValidatorString(array('max_length' => 255)),
      'adres'         => new sfValidatorString(array('max_length' => 255)),
      'quantity'      => new sfValidatorInteger(array('min' => -2147483648, 'max' => 2147483647, 'required' => false)),
      'accepted'      => new sfValidatorBoolean(array('required' => false)),
      'short_content' => new sfValidatorString(array('required' => false)),
      'image1'        => new sfValidatorString(array('max_length' => 255)),
      'image2'        => new sfValidatorString(array('max_length' => 255, 'required' => false)),
      'image3'        => new sfValidatorString(array('max_length' => 255, 'required' => false)),
    ));

    $this->widgetSchema->setNameFormat('rent[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'Rent';
  }


}
