<?php

/**
 * UserActivity form base class.
 *
 * @method UserActivity getObject() Returns the current form's model object
 *
 * @package    Kiwi
 * @subpackage form
 * @author     Your name here
 */
abstract class BaseUserActivityForm extends BaseFormPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'id'               => new sfWidgetFormInputHidden(),
      'status'           => new sfWidgetFormInputText(),
      'user_id'          => new sfWidgetFormPropelChoice(array('model' => 'User', 'add_empty' => true)),
      'activity_id'      => new sfWidgetFormPropelChoice(array('model' => 'Activity', 'add_empty' => true)),
      'comment'          => new sfWidgetFormInputText(),
      'application_date' => new sfWidgetFormDate(),
    ));

    $this->setValidators(array(
      'id'               => new sfValidatorChoice(array('choices' => array($this->getObject()->getId()), 'empty_value' => $this->getObject()->getId(), 'required' => false)),
      'status'           => new sfValidatorInteger(array('min' => -2147483648, 'max' => 2147483647, 'required' => false)),
      'user_id'          => new sfValidatorPropelChoice(array('model' => 'User', 'column' => 'id', 'required' => false)),
      'activity_id'      => new sfValidatorPropelChoice(array('model' => 'Activity', 'column' => 'id', 'required' => false)),
      'comment'          => new sfValidatorString(array('max_length' => 255)),
      'application_date' => new sfValidatorDate(array('required' => false)),
    ));

    $this->widgetSchema->setNameFormat('user_activity[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'UserActivity';
  }


}
