<?php

/**
 * User form base class.
 *
 * @method User getObject() Returns the current form's model object
 *
 * @package    Kiwi
 * @subpackage form
 * @author     Your name here
 */
abstract class BaseUserForm extends BaseFormPropel
{
  public function setup()
  {
    $this->setWidgets(array(
      'id'          => new sfWidgetFormInputHidden(),
      'category_id' => new sfWidgetFormPropelChoice(array('model' => 'UserType', 'add_empty' => false)),
      'email'       => new sfWidgetFormInputText(),
      'password'    => new sfWidgetFormInputText(),
      'name'        => new sfWidgetFormInputText(),
      'first_login' => new sfWidgetFormInputCheckbox(),
      'deleted'     => new sfWidgetFormInputCheckbox(),
      'token'       => new sfWidgetFormInputText(),
      'created'     => new sfWidgetFormDate(),
      'comment'     => new sfWidgetFormInputCheckbox(),
    ));

    $this->setValidators(array(
      'id'          => new sfValidatorChoice(array('choices' => array($this->getObject()->getId()), 'empty_value' => $this->getObject()->getId(), 'required' => false)),
      'category_id' => new sfValidatorPropelChoice(array('model' => 'UserType', 'column' => 'id')),
      'email'       => new sfValidatorString(array('max_length' => 255)),
      'password'    => new sfValidatorString(array('max_length' => 255, 'required' => false)),
      'name'        => new sfValidatorString(array('max_length' => 255)),
      'first_login' => new sfValidatorBoolean(array('required' => false)),
      'deleted'     => new sfValidatorBoolean(array('required' => false)),
      'token'       => new sfValidatorString(array('max_length' => 255, 'required' => false)),
      'created'     => new sfValidatorDate(array('required' => false)),
      'comment'     => new sfValidatorBoolean(array('required' => false)),
    ));

    $this->widgetSchema->setNameFormat('user[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'User';
  }


}
