<?php


/**
 * Skeleton subclass for performing query and update operations on the 'activity' table.
 *
 * 
 *
 * This class was autogenerated by Propel 1.4.2 on:
 *
 * 03/02/11 20:21:59
 *
 * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package    lib.model
 */
class ActivityPeer extends BaseActivityPeer {
public static function doSelectForAdmin(Criteria $criteria, PropelPDO $con = null)
	{
		$user = sfContext::getInstance()->getUser();
		
		if(!$user->hasCredential("Admin"))
			$criteria->add(	ActivityPeer::USER_ID, 
						$user->getUserObject()->getId(), 
						Criteria::EQUAL);
						
		return ActivityPeer::doSelect($criteria, $con);
	}
	
	public static function doCountForAdmin(Criteria $criteria, $distinct = false, PropelPDO $con = null)
	{
		$user = sfContext::getInstance()->getUser();
		
		if(!$user->hasCredential("Admin"))
			$criteria->add(	ActivityPeer::USER_ID, 
						$user->getUserObject()->getId(), 
						Criteria::EQUAL);
		return ActivityPeer::doCount( $criteria, $distinct,  $con);
	}
	
	public static function sendNewsletter($activities, $volunteers) {
	
		if(count($activities) > 0) {
			$tmp = "";
			foreach($activities as $activity) {
				$tmp = $tmp.EmailHelper::createLink("/activity/details/".$activity->getId(), $activity->getTitle())."<br />";
				$activity->setIsSent(true);
				$activity->save();
			}
			foreach($volunteers as $v) {
				EmailHelper::sendMessage(EmailHelper::$kiwiEmail,
										EmailHelper::$kiwiAlias,
										array( $v->getUser()->getEmail() =>	$v->getUser()->getName()),
											 "Email newsletter", 
										array(
												  	"link" => $tmp,
												  	"unsubscribe" => EmailHelper::createLink("/activity/unsubscribe?token=".$v->getUser()->getToken(), "Zrezygnuj z newsletetra"),
												  	"name" => $v->getUser()->getName()
										));
			}
		}
	}
	
	
	
	public static function sendNewOffer($activity) {
	EmailHelper::sendMessage(EmailHelper::$kiwiEmail,
							EmailHelper::$kiwiAlias,
							array(EmailHelper::$offerEmail => EmailHelper::$kiwiAlias),
							"Email o nowej ofercie",
							array(
								"link" => EmailHelper::createLink("/activity/details/".$activity->getId(), $activity->getTitle()),
								"user" => EmailHelper::createLink("/user/foundation/".$activity->getUser()->getId(), $activity->getUser()->getName())
	));
	
	
	}
	public static function sendApplicationNotLogged($activity, $email, $phone){
	
			EmailHelper::sendMessage(EmailHelper::$kiwiEmail,
								EmailHelper::$kiwiAlias,
								array($email =>	$email),
								"Email aplikacji do niezarejestrowanego nadawcy",
								array(
									"link" => EmailHelper::createLink("/activity/details/".$activity->getId(), $activity->getTitle()),
									"email" => EmailHelper::createEmail($email)
									));
			
			EmailHelper::sendMessage(EmailHelper::$kiwiEmail,
									EmailHelper::$kiwiAlias,
									array(EmailHelper::$offerEmail => EmailHelper::$kiwiAlias),
									"Email aplikacji od niezarejestrowanego nadawcy do zespołu kiwi",
									array(
										"link" => EmailHelper::createLink("/activity/details/".$activity->getId(), $activity->getTitle()),
									 	"email" => EmailHelper::createEmail($email),
									  	"phone" => $phone
		));
		
		}
		public static function sendApplicationLogged($activity, Volunteer $volunteer){
		
			EmailHelper::sendMessage(EmailHelper::$kiwiEmail,
								EmailHelper::$kiwiAlias,
								array($volunteer->getUser()->getEmail() => $volunteer->getUser()->getName()),
								"Email aplikacji do zarejestrowanego nadawcy",
								array(
									"link" => EmailHelper::createLink("/activity/details/".$activity->getId(), $activity->getTitle()),
									"name" => $volunteer->getUser()->getName(),
									"email" => EmailHelper::createEmail($volunteer->getUser()->getEmail())
								));
			
			EmailHelper::sendMessage(EmailHelper::$kiwiEmail,
									EmailHelper::$kiwiAlias,
									array(EmailHelper::$offerEmail => EmailHelper::$kiwiAlias),
									"Email aplikacji od zarejestrowanego nadawcy do zespołu kiwi",
									array(
										"link" => EmailHelper::createLink("/activity/details/".$activity->getId(), $activity->getTitle()),
										"name" => $volunteer->getUser()->getName(),
										"email" => EmailHelper::createEmail($volunteer->getUser()->getEmail()),
										"user" => EmailHelper::createLink("/user/volunteer/".$volunteer->getUser()->getId(), $volunteer->getUser()->getName()),
									));
	
		}
	
} // ActivityPeer
