<?php


/**
 * Skeleton subclass for representing a row from the 'user' table.
 *
 * 
 *
 * This class was autogenerated by Propel 1.4.2 on:
 *
 * 03/04/11 17:21:49
 *
 * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package    lib.model
 */
class User extends BaseUser {
public function __toString()
  {
    return $this->getName();
  }
  public function save(PropelPDO $con = null, $sendEmail = true, $password = null)
  {
  	if($this->isNew()) {
		if (!$password) {
			$password = formHelper::generateRandomString(rand(6,12), 7);
		}
  		$this->setPassword(md5($password));
  		$this->setToken(formHelper::generateRandomString(50, 7));
  		$this->setFirstLogin(false);
  		$this->setDeleted(false);
  		$this->setCreated(time());
		if ($sendEmail) {
			UserPeer::sendPassword($this, $password);
		}
  	}
  	$res =  parent::save($con);
  	
  	
  	return $res;
  }
  
  public function delete(PropelPDO $con = null)
  {
  	foreach($this->getUserGroups() as $ug)
  		$ug->delete();
  	foreach($this->getFoundations() as $ug)
  		$ug->delete();
  	foreach($this->getVolunteers() as $ug)
  		$ug->delete();
  	foreach($this->getActivitys() as $ug)
  		$ug->delete();
  	foreach($this->getUserActivitys() as $ug)
  		$ug->delete();
  	parent::delete($con);
  }
  
  
  	public function getVolunteerObject() {
  		$criteria = new Criteria();
  		$criteria->add(VolunteerPeer::USER_ID, $this->getId() , Criteria::EQUAL);
  		return VolunteerPeer::doSelectOne($criteria);
  	}
} // User
