<?php


/**
 * This class defines the structure of the 'activity' table.
 *
 *
 * This class was autogenerated by Propel 1.4.2 on:
 *
 * 11/11/16 11:30:15
 *
 *
 * This map class is used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive
 * (i.e. if it's a text column type).
 *
 * @package    lib.model.map
 */
class ActivityTableMap extends TableMap {

	/**
	 * The (dot-path) name of this class
	 */
	const CLASS_NAME = 'lib.model.map.ActivityTableMap';

	/**
	 * Initialize the table attributes, columns and validators
	 * Relations are not initialized by this method since they are lazy loaded
	 *
	 * @return     void
	 * @throws     PropelException
	 */
	public function initialize()
	{
	  // attributes
		$this->setName('activity');
		$this->setPhpName('Activity');
		$this->setClassname('Activity');
		$this->setPackage('lib.model');
		$this->setUseIdGenerator(true);
		// columns
		$this->addPrimaryKey('ID', 'Id', 'INTEGER', true, null, null);
		$this->addColumn('TITLE', 'Title', 'VARCHAR', true, 255, null);
		$this->addColumn('CONTENT', 'Content', 'LONGVARCHAR', true, null, null);
		$this->addColumn('IS_CONSTANT', 'IsConstant', 'BOOLEAN', false, null, null);
		$this->addColumn('IS_INTERNET', 'IsInternet', 'BOOLEAN', false, null, null);
		$this->addColumn('IS_SENT', 'IsSent', 'BOOLEAN', false, null, null);
		$this->addColumn('STARTS_AT', 'StartsAt', 'DATE', false, null, null);
		$this->addColumn('FINISHES_AT', 'FinishesAt', 'DATE', false, null, null);
		$this->addColumn('CREATED_AT', 'CreatedAt', 'TIMESTAMP', true, null, null);
		$this->addColumn('DELETE_AT', 'DeleteAt', 'DATE', false, null, null);
		$this->addColumn('PLACES_AVAILABLE', 'PlacesAvailable', 'INTEGER', false, null, null);
		$this->addForeignKey('USER_ID', 'UserId', 'INTEGER', 'user', 'ID', true, null, null);
		$this->addForeignKey('GROUP_ID', 'GroupId', 'INTEGER', 'group_category', 'ID', false, null, null);
		$this->addColumn('CONTACT_PERSON', 'ContactPerson', 'VARCHAR', true, 255, null);
		$this->addColumn('EMAIL', 'Email', 'VARCHAR', true, 255, null);
		$this->addColumn('PHONE', 'Phone', 'VARCHAR', true, 255, null);
		$this->addColumn('LATITUDE', 'Latitude', 'VARCHAR', false, 25, null);
		$this->addColumn('LONGITUDE', 'Longitude', 'VARCHAR', false, 25, null);
		$this->addColumn('ADDRESS', 'Address', 'VARCHAR', false, 255, null);
		$this->addColumn('ARCHIVED', 'Archived', 'BOOLEAN', false, null, null);
		$this->addColumn('SPECIAL', 'Special', 'BOOLEAN', false, null, null);
		$this->addColumn('POSITION', 'Position', 'INTEGER', false, null, null);
		// validators
	} // initialize()

	/**
	 * Build the RelationMap objects for this table relationships
	 */
	public function buildRelations()
	{
    $this->addRelation('User', 'User', RelationMap::MANY_TO_ONE, array('user_id' => 'id', ), null, null);
    $this->addRelation('GroupCategory', 'GroupCategory', RelationMap::MANY_TO_ONE, array('group_id' => 'id', ), null, null);
    $this->addRelation('UserActivity', 'UserActivity', RelationMap::ONE_TO_MANY, array('id' => 'activity_id', ), null, null);
    $this->addRelation('MeetingUser', 'MeetingUser', RelationMap::ONE_TO_MANY, array('id' => 'activity_id', ), null, null);
	} // buildRelations()

	/**
	 * 
	 * Gets the list of behaviors registered for this table
	 * 
	 * @return array Associative array (name => parameters) of behaviors
	 */
	public function getBehaviors()
	{
		return array(
			'symfony' => array('form' => 'true', 'filter' => 'true', ),
			'symfony_behaviors' => array(),
			'symfony_timestampable' => array('create_column' => 'created_at', ),
		);
	} // getBehaviors()

} // ActivityTableMap
