<?php


/**
 * This class defines the structure of the 'foundation' table.
 *
 *
 * This class was autogenerated by Propel 1.4.2 on:
 *
 * 11/11/16 11:30:15
 *
 *
 * This map class is used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive
 * (i.e. if it's a text column type).
 *
 * @package    lib.model.map
 */
class FoundationTableMap extends TableMap {

	/**
	 * The (dot-path) name of this class
	 */
	const CLASS_NAME = 'lib.model.map.FoundationTableMap';

	/**
	 * Initialize the table attributes, columns and validators
	 * Relations are not initialized by this method since they are lazy loaded
	 *
	 * @return     void
	 * @throws     PropelException
	 */
	public function initialize()
	{
	  // attributes
		$this->setName('foundation');
		$this->setPhpName('Foundation');
		$this->setClassname('Foundation');
		$this->setPackage('lib.model');
		$this->setUseIdGenerator(true);
		// columns
		$this->addPrimaryKey('ID', 'Id', 'INTEGER', true, null, null);
		$this->addForeignKey('USER_ID', 'UserId', 'INTEGER', 'user', 'ID', true, null, null);
		$this->addColumn('LOGO', 'Logo', 'VARCHAR', false, 255, null);
		$this->addColumn('CONTENT', 'Content', 'LONGVARCHAR', false, null, null);
		$this->addColumn('CONTACT_PERSON', 'ContactPerson', 'VARCHAR', false, 255, null);
		$this->addColumn('LATITUDE', 'Latitude', 'VARCHAR', false, 25, null);
		$this->addColumn('LONGITUDE', 'Longitude', 'VARCHAR', false, 25, null);
		$this->addColumn('ADDRESS', 'Address', 'VARCHAR', false, 255, null);
		$this->addForeignKey('DISTRICT_ID', 'DistrictId', 'INTEGER', 'district', 'ID', true, null, 1);
		$this->addColumn('PHONE', 'Phone', 'VARCHAR', false, 255, null);
		$this->addColumn('WWW', 'Www', 'VARCHAR', false, 255, null);
		$this->addColumn('AREA0', 'Area0', 'BOOLEAN', false, null, null);
		$this->addColumn('AREA1', 'Area1', 'BOOLEAN', false, null, null);
		$this->addColumn('AREA2', 'Area2', 'BOOLEAN', false, null, null);
		$this->addColumn('AREA3', 'Area3', 'BOOLEAN', false, null, null);
		$this->addColumn('AREA4', 'Area4', 'BOOLEAN', false, null, null);
		$this->addColumn('AREA5', 'Area5', 'BOOLEAN', false, null, null);
		$this->addColumn('AREA6', 'Area6', 'BOOLEAN', false, null, null);
		$this->addColumn('ACTIVE', 'Active', 'BOOLEAN', true, null, true);
		// validators
	} // initialize()

	/**
	 * Build the RelationMap objects for this table relationships
	 */
	public function buildRelations()
	{
    $this->addRelation('User', 'User', RelationMap::MANY_TO_ONE, array('user_id' => 'id', ), null, null);
    $this->addRelation('District', 'District', RelationMap::MANY_TO_ONE, array('district_id' => 'id', ), null, null);
    $this->addRelation('FoundationImage', 'FoundationImage', RelationMap::ONE_TO_MANY, array('id' => 'foundation_id', ), null, null);
	} // buildRelations()

	/**
	 * 
	 * Gets the list of behaviors registered for this table
	 * 
	 * @return array Associative array (name => parameters) of behaviors
	 */
	public function getBehaviors()
	{
		return array(
			'symfony' => array('form' => 'true', 'filter' => 'true', ),
			'symfony_behaviors' => array(),
		);
	} // getBehaviors()

} // FoundationTableMap
