<?php

/**
 * Base class that represents a row from the 'activity' table.
 *
 * 
 *
 * This class was autogenerated by Propel 1.4.2 on:
 *
 * 11/11/16 11:30:15
 *
 * @package    lib.model.om
 */
abstract class BaseActivity extends BaseObject  implements Persistent {


	/**
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var        ActivityPeer
	 */
	protected static $peer;

	/**
	 * The value for the id field.
	 * @var        int
	 */
	protected $id;

	/**
	 * The value for the title field.
	 * @var        string
	 */
	protected $title;

	/**
	 * The value for the content field.
	 * @var        string
	 */
	protected $content;

	/**
	 * The value for the is_constant field.
	 * @var        boolean
	 */
	protected $is_constant;

	/**
	 * The value for the is_internet field.
	 * @var        boolean
	 */
	protected $is_internet;

	/**
	 * The value for the is_sent field.
	 * @var        boolean
	 */
	protected $is_sent;

	/**
	 * The value for the starts_at field.
	 * @var        string
	 */
	protected $starts_at;

	/**
	 * The value for the finishes_at field.
	 * @var        string
	 */
	protected $finishes_at;

	/**
	 * The value for the created_at field.
	 * @var        string
	 */
	protected $created_at;

	/**
	 * The value for the delete_at field.
	 * @var        string
	 */
	protected $delete_at;

	/**
	 * The value for the places_available field.
	 * @var        int
	 */
	protected $places_available;

	/**
	 * The value for the user_id field.
	 * @var        int
	 */
	protected $user_id;

	/**
	 * The value for the group_id field.
	 * @var        int
	 */
	protected $group_id;

	/**
	 * The value for the contact_person field.
	 * @var        string
	 */
	protected $contact_person;

	/**
	 * The value for the email field.
	 * @var        string
	 */
	protected $email;

	/**
	 * The value for the phone field.
	 * @var        string
	 */
	protected $phone;

	/**
	 * The value for the latitude field.
	 * @var        string
	 */
	protected $latitude;

	/**
	 * The value for the longitude field.
	 * @var        string
	 */
	protected $longitude;

	/**
	 * The value for the address field.
	 * @var        string
	 */
	protected $address;

	/**
	 * The value for the archived field.
	 * @var        boolean
	 */
	protected $archived;

	/**
	 * The value for the special field.
	 * @var        boolean
	 */
	protected $special;

	/**
	 * The value for the position field.
	 * @var        int
	 */
	protected $position;

	/**
	 * @var        User
	 */
	protected $aUser;

	/**
	 * @var        GroupCategory
	 */
	protected $aGroupCategory;

	/**
	 * @var        array UserActivity[] Collection to store aggregation of UserActivity objects.
	 */
	protected $collUserActivitys;

	/**
	 * @var        Criteria The criteria used to select the current contents of collUserActivitys.
	 */
	private $lastUserActivityCriteria = null;

	/**
	 * @var        array MeetingUser[] Collection to store aggregation of MeetingUser objects.
	 */
	protected $collMeetingUsers;

	/**
	 * @var        Criteria The criteria used to select the current contents of collMeetingUsers.
	 */
	private $lastMeetingUserCriteria = null;

	/**
	 * Flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInSave = false;

	/**
	 * Flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInValidation = false;

	// symfony behavior
	
	const PEER = 'ActivityPeer';

	/**
	 * Get the [id] column value.
	 * 
	 * @return     int
	 */
	public function getId()
	{
		return $this->id;
	}

	/**
	 * Get the [title] column value.
	 * 
	 * @return     string
	 */
	public function getTitle()
	{
		return $this->title;
	}

	/**
	 * Get the [content] column value.
	 * 
	 * @return     string
	 */
	public function getContent()
	{
		return $this->content;
	}

	/**
	 * Get the [is_constant] column value.
	 * 
	 * @return     boolean
	 */
	public function getIsConstant()
	{
		return $this->is_constant;
	}

	/**
	 * Get the [is_internet] column value.
	 * 
	 * @return     boolean
	 */
	public function getIsInternet()
	{
		return $this->is_internet;
	}

	/**
	 * Get the [is_sent] column value.
	 * 
	 * @return     boolean
	 */
	public function getIsSent()
	{
		return $this->is_sent;
	}

	/**
	 * Get the [optionally formatted] temporal [starts_at] column value.
	 * 
	 *
	 * @param      string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the raw DateTime object will be returned.
	 * @return     mixed Formatted date/time value as string or DateTime object (if format is NULL), NULL if column is NULL, and 0 if column value is 0000-00-00
	 * @throws     PropelException - if unable to parse/validate the date/time value.
	 */
	public function getStartsAt($format = 'Y-m-d')
	{
		if ($this->starts_at === null) {
			return null;
		}


		if ($this->starts_at === '0000-00-00') {
			// while technically this is not a default value of NULL,
			// this seems to be closest in meaning.
			return null;
		} else {
			try {
				$dt = new DateTime($this->starts_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->starts_at, true), $x);
			}
		}

		if ($format === null) {
			// Because propel.useDateTimeClass is TRUE, we return a DateTime object.
			return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	/**
	 * Get the [optionally formatted] temporal [finishes_at] column value.
	 * 
	 *
	 * @param      string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the raw DateTime object will be returned.
	 * @return     mixed Formatted date/time value as string or DateTime object (if format is NULL), NULL if column is NULL, and 0 if column value is 0000-00-00
	 * @throws     PropelException - if unable to parse/validate the date/time value.
	 */
	public function getFinishesAt($format = 'Y-m-d')
	{
		if ($this->finishes_at === null) {
			return null;
		}


		if ($this->finishes_at === '0000-00-00') {
			// while technically this is not a default value of NULL,
			// this seems to be closest in meaning.
			return null;
		} else {
			try {
				$dt = new DateTime($this->finishes_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->finishes_at, true), $x);
			}
		}

		if ($format === null) {
			// Because propel.useDateTimeClass is TRUE, we return a DateTime object.
			return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	/**
	 * Get the [optionally formatted] temporal [created_at] column value.
	 * 
	 *
	 * @param      string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the raw DateTime object will be returned.
	 * @return     mixed Formatted date/time value as string or DateTime object (if format is NULL), NULL if column is NULL, and 0 if column value is 0000-00-00 00:00:00
	 * @throws     PropelException - if unable to parse/validate the date/time value.
	 */
	public function getCreatedAt($format = 'Y-m-d H:i:s')
	{
		if ($this->created_at === null) {
			return null;
		}


		if ($this->created_at === '0000-00-00 00:00:00') {
			// while technically this is not a default value of NULL,
			// this seems to be closest in meaning.
			return null;
		} else {
			try {
				$dt = new DateTime($this->created_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->created_at, true), $x);
			}
		}

		if ($format === null) {
			// Because propel.useDateTimeClass is TRUE, we return a DateTime object.
			return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	/**
	 * Get the [optionally formatted] temporal [delete_at] column value.
	 * 
	 *
	 * @param      string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the raw DateTime object will be returned.
	 * @return     mixed Formatted date/time value as string or DateTime object (if format is NULL), NULL if column is NULL, and 0 if column value is 0000-00-00
	 * @throws     PropelException - if unable to parse/validate the date/time value.
	 */
	public function getDeleteAt($format = 'Y-m-d')
	{
		if ($this->delete_at === null) {
			return null;
		}


		if ($this->delete_at === '0000-00-00') {
			// while technically this is not a default value of NULL,
			// this seems to be closest in meaning.
			return null;
		} else {
			try {
				$dt = new DateTime($this->delete_at);
			} catch (Exception $x) {
				throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->delete_at, true), $x);
			}
		}

		if ($format === null) {
			// Because propel.useDateTimeClass is TRUE, we return a DateTime object.
			return $dt;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $dt->format('U'));
		} else {
			return $dt->format($format);
		}
	}

	/**
	 * Get the [places_available] column value.
	 * 
	 * @return     int
	 */
	public function getPlacesAvailable()
	{
		return $this->places_available;
	}

	/**
	 * Get the [user_id] column value.
	 * 
	 * @return     int
	 */
	public function getUserId()
	{
		return $this->user_id;
	}

	/**
	 * Get the [group_id] column value.
	 * 
	 * @return     int
	 */
	public function getGroupId()
	{
		return $this->group_id;
	}

	/**
	 * Get the [contact_person] column value.
	 * 
	 * @return     string
	 */
	public function getContactPerson()
	{
		return $this->contact_person;
	}

	/**
	 * Get the [email] column value.
	 * 
	 * @return     string
	 */
	public function getEmail()
	{
		return $this->email;
	}

	/**
	 * Get the [phone] column value.
	 * 
	 * @return     string
	 */
	public function getPhone()
	{
		return $this->phone;
	}

	/**
	 * Get the [latitude] column value.
	 * 
	 * @return     string
	 */
	public function getLatitude()
	{
		return $this->latitude;
	}

	/**
	 * Get the [longitude] column value.
	 * 
	 * @return     string
	 */
	public function getLongitude()
	{
		return $this->longitude;
	}

	/**
	 * Get the [address] column value.
	 * 
	 * @return     string
	 */
	public function getAddress()
	{
		return $this->address;
	}

	/**
	 * Get the [archived] column value.
	 * 
	 * @return     boolean
	 */
	public function getArchived()
	{
		return $this->archived;
	}

	/**
	 * Get the [special] column value.
	 * 
	 * @return     boolean
	 */
	public function getSpecial()
	{
		return $this->special;
	}

	/**
	 * Get the [position] column value.
	 * 
	 * @return     int
	 */
	public function getPosition()
	{
		return $this->position;
	}

	/**
	 * Set the value of [id] column.
	 * 
	 * @param      int $v new value
	 * @return     Activity The current object (for fluent API support)
	 */
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = ActivityPeer::ID;
		}

		return $this;
	} // setId()

	/**
	 * Set the value of [title] column.
	 * 
	 * @param      string $v new value
	 * @return     Activity The current object (for fluent API support)
	 */
	public function setTitle($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->title !== $v) {
			$this->title = $v;
			$this->modifiedColumns[] = ActivityPeer::TITLE;
		}

		return $this;
	} // setTitle()

	/**
	 * Set the value of [content] column.
	 * 
	 * @param      string $v new value
	 * @return     Activity The current object (for fluent API support)
	 */
	public function setContent($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->content !== $v) {
			$this->content = $v;
			$this->modifiedColumns[] = ActivityPeer::CONTENT;
		}

		return $this;
	} // setContent()

	/**
	 * Set the value of [is_constant] column.
	 * 
	 * @param      boolean $v new value
	 * @return     Activity The current object (for fluent API support)
	 */
	public function setIsConstant($v)
	{
		if ($v !== null) {
			$v = (boolean) $v;
		}

		if ($this->is_constant !== $v) {
			$this->is_constant = $v;
			$this->modifiedColumns[] = ActivityPeer::IS_CONSTANT;
		}

		return $this;
	} // setIsConstant()

	/**
	 * Set the value of [is_internet] column.
	 * 
	 * @param      boolean $v new value
	 * @return     Activity The current object (for fluent API support)
	 */
	public function setIsInternet($v)
	{
		if ($v !== null) {
			$v = (boolean) $v;
		}

		if ($this->is_internet !== $v) {
			$this->is_internet = $v;
			$this->modifiedColumns[] = ActivityPeer::IS_INTERNET;
		}

		return $this;
	} // setIsInternet()

	/**
	 * Set the value of [is_sent] column.
	 * 
	 * @param      boolean $v new value
	 * @return     Activity The current object (for fluent API support)
	 */
	public function setIsSent($v)
	{
		if ($v !== null) {
			$v = (boolean) $v;
		}

		if ($this->is_sent !== $v) {
			$this->is_sent = $v;
			$this->modifiedColumns[] = ActivityPeer::IS_SENT;
		}

		return $this;
	} // setIsSent()

	/**
	 * Sets the value of [starts_at] column to a normalized version of the date/time value specified.
	 * 
	 * @param      mixed $v string, integer (timestamp), or DateTime value.  Empty string will
	 *						be treated as NULL for temporal objects.
	 * @return     Activity The current object (for fluent API support)
	 */
	public function setStartsAt($v)
	{
		// we treat '' as NULL for temporal objects because DateTime('') == DateTime('now')
		// -- which is unexpected, to say the least.
		if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
			// some string/numeric value passed; we normalize that so that we can
			// validate it.
			try {
				if (is_numeric($v)) { // if it's a unix timestamp
					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
					// We have to explicitly specify and then change the time zone because of a
					// DateTime bug: http://bugs.php.net/bug.php?id=43003
					$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->starts_at !== null || $dt !== null ) {
			// (nested ifs are a little easier to read in this case)

			$currNorm = ($this->starts_at !== null && $tmpDt = new DateTime($this->starts_at)) ? $tmpDt->format('Y-m-d') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d') : null;

			if ( ($currNorm !== $newNorm) // normalized values don't match 
					)
			{
				$this->starts_at = ($dt ? $dt->format('Y-m-d') : null);
				$this->modifiedColumns[] = ActivityPeer::STARTS_AT;
			}
		} // if either are not null

		return $this;
	} // setStartsAt()

	/**
	 * Sets the value of [finishes_at] column to a normalized version of the date/time value specified.
	 * 
	 * @param      mixed $v string, integer (timestamp), or DateTime value.  Empty string will
	 *						be treated as NULL for temporal objects.
	 * @return     Activity The current object (for fluent API support)
	 */
	public function setFinishesAt($v)
	{
		// we treat '' as NULL for temporal objects because DateTime('') == DateTime('now')
		// -- which is unexpected, to say the least.
		if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
			// some string/numeric value passed; we normalize that so that we can
			// validate it.
			try {
				if (is_numeric($v)) { // if it's a unix timestamp
					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
					// We have to explicitly specify and then change the time zone because of a
					// DateTime bug: http://bugs.php.net/bug.php?id=43003
					$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->finishes_at !== null || $dt !== null ) {
			// (nested ifs are a little easier to read in this case)

			$currNorm = ($this->finishes_at !== null && $tmpDt = new DateTime($this->finishes_at)) ? $tmpDt->format('Y-m-d') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d') : null;

			if ( ($currNorm !== $newNorm) // normalized values don't match 
					)
			{
				$this->finishes_at = ($dt ? $dt->format('Y-m-d') : null);
				$this->modifiedColumns[] = ActivityPeer::FINISHES_AT;
			}
		} // if either are not null

		return $this;
	} // setFinishesAt()

	/**
	 * Sets the value of [created_at] column to a normalized version of the date/time value specified.
	 * 
	 * @param      mixed $v string, integer (timestamp), or DateTime value.  Empty string will
	 *						be treated as NULL for temporal objects.
	 * @return     Activity The current object (for fluent API support)
	 */
	public function setCreatedAt($v)
	{
		// we treat '' as NULL for temporal objects because DateTime('') == DateTime('now')
		// -- which is unexpected, to say the least.
		if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
			// some string/numeric value passed; we normalize that so that we can
			// validate it.
			try {
				if (is_numeric($v)) { // if it's a unix timestamp
					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
					// We have to explicitly specify and then change the time zone because of a
					// DateTime bug: http://bugs.php.net/bug.php?id=43003
					$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->created_at !== null || $dt !== null ) {
			// (nested ifs are a little easier to read in this case)

			$currNorm = ($this->created_at !== null && $tmpDt = new DateTime($this->created_at)) ? $tmpDt->format('Y-m-d H:i:s') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d H:i:s') : null;

			if ( ($currNorm !== $newNorm) // normalized values don't match 
					)
			{
				$this->created_at = ($dt ? $dt->format('Y-m-d H:i:s') : null);
				$this->modifiedColumns[] = ActivityPeer::CREATED_AT;
			}
		} // if either are not null

		return $this;
	} // setCreatedAt()

	/**
	 * Sets the value of [delete_at] column to a normalized version of the date/time value specified.
	 * 
	 * @param      mixed $v string, integer (timestamp), or DateTime value.  Empty string will
	 *						be treated as NULL for temporal objects.
	 * @return     Activity The current object (for fluent API support)
	 */
	public function setDeleteAt($v)
	{
		// we treat '' as NULL for temporal objects because DateTime('') == DateTime('now')
		// -- which is unexpected, to say the least.
		if ($v === null || $v === '') {
			$dt = null;
		} elseif ($v instanceof DateTime) {
			$dt = $v;
		} else {
			// some string/numeric value passed; we normalize that so that we can
			// validate it.
			try {
				if (is_numeric($v)) { // if it's a unix timestamp
					$dt = new DateTime('@'.$v, new DateTimeZone('UTC'));
					// We have to explicitly specify and then change the time zone because of a
					// DateTime bug: http://bugs.php.net/bug.php?id=43003
					$dt->setTimeZone(new DateTimeZone(date_default_timezone_get()));
				} else {
					$dt = new DateTime($v);
				}
			} catch (Exception $x) {
				throw new PropelException('Error parsing date/time value: ' . var_export($v, true), $x);
			}
		}

		if ( $this->delete_at !== null || $dt !== null ) {
			// (nested ifs are a little easier to read in this case)

			$currNorm = ($this->delete_at !== null && $tmpDt = new DateTime($this->delete_at)) ? $tmpDt->format('Y-m-d') : null;
			$newNorm = ($dt !== null) ? $dt->format('Y-m-d') : null;

			if ( ($currNorm !== $newNorm) // normalized values don't match 
					)
			{
				$this->delete_at = ($dt ? $dt->format('Y-m-d') : null);
				$this->modifiedColumns[] = ActivityPeer::DELETE_AT;
			}
		} // if either are not null

		return $this;
	} // setDeleteAt()

	/**
	 * Set the value of [places_available] column.
	 * 
	 * @param      int $v new value
	 * @return     Activity The current object (for fluent API support)
	 */
	public function setPlacesAvailable($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->places_available !== $v) {
			$this->places_available = $v;
			$this->modifiedColumns[] = ActivityPeer::PLACES_AVAILABLE;
		}

		return $this;
	} // setPlacesAvailable()

	/**
	 * Set the value of [user_id] column.
	 * 
	 * @param      int $v new value
	 * @return     Activity The current object (for fluent API support)
	 */
	public function setUserId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->user_id !== $v) {
			$this->user_id = $v;
			$this->modifiedColumns[] = ActivityPeer::USER_ID;
		}

		if ($this->aUser !== null && $this->aUser->getId() !== $v) {
			$this->aUser = null;
		}

		return $this;
	} // setUserId()

	/**
	 * Set the value of [group_id] column.
	 * 
	 * @param      int $v new value
	 * @return     Activity The current object (for fluent API support)
	 */
	public function setGroupId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->group_id !== $v) {
			$this->group_id = $v;
			$this->modifiedColumns[] = ActivityPeer::GROUP_ID;
		}

		if ($this->aGroupCategory !== null && $this->aGroupCategory->getId() !== $v) {
			$this->aGroupCategory = null;
		}

		return $this;
	} // setGroupId()

	/**
	 * Set the value of [contact_person] column.
	 * 
	 * @param      string $v new value
	 * @return     Activity The current object (for fluent API support)
	 */
	public function setContactPerson($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->contact_person !== $v) {
			$this->contact_person = $v;
			$this->modifiedColumns[] = ActivityPeer::CONTACT_PERSON;
		}

		return $this;
	} // setContactPerson()

	/**
	 * Set the value of [email] column.
	 * 
	 * @param      string $v new value
	 * @return     Activity The current object (for fluent API support)
	 */
	public function setEmail($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->email !== $v) {
			$this->email = $v;
			$this->modifiedColumns[] = ActivityPeer::EMAIL;
		}

		return $this;
	} // setEmail()

	/**
	 * Set the value of [phone] column.
	 * 
	 * @param      string $v new value
	 * @return     Activity The current object (for fluent API support)
	 */
	public function setPhone($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->phone !== $v) {
			$this->phone = $v;
			$this->modifiedColumns[] = ActivityPeer::PHONE;
		}

		return $this;
	} // setPhone()

	/**
	 * Set the value of [latitude] column.
	 * 
	 * @param      string $v new value
	 * @return     Activity The current object (for fluent API support)
	 */
	public function setLatitude($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->latitude !== $v) {
			$this->latitude = $v;
			$this->modifiedColumns[] = ActivityPeer::LATITUDE;
		}

		return $this;
	} // setLatitude()

	/**
	 * Set the value of [longitude] column.
	 * 
	 * @param      string $v new value
	 * @return     Activity The current object (for fluent API support)
	 */
	public function setLongitude($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->longitude !== $v) {
			$this->longitude = $v;
			$this->modifiedColumns[] = ActivityPeer::LONGITUDE;
		}

		return $this;
	} // setLongitude()

	/**
	 * Set the value of [address] column.
	 * 
	 * @param      string $v new value
	 * @return     Activity The current object (for fluent API support)
	 */
	public function setAddress($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->address !== $v) {
			$this->address = $v;
			$this->modifiedColumns[] = ActivityPeer::ADDRESS;
		}

		return $this;
	} // setAddress()

	/**
	 * Set the value of [archived] column.
	 * 
	 * @param      boolean $v new value
	 * @return     Activity The current object (for fluent API support)
	 */
	public function setArchived($v)
	{
		if ($v !== null) {
			$v = (boolean) $v;
		}

		if ($this->archived !== $v) {
			$this->archived = $v;
			$this->modifiedColumns[] = ActivityPeer::ARCHIVED;
		}

		return $this;
	} // setArchived()

	/**
	 * Set the value of [special] column.
	 * 
	 * @param      boolean $v new value
	 * @return     Activity The current object (for fluent API support)
	 */
	public function setSpecial($v)
	{
		if ($v !== null) {
			$v = (boolean) $v;
		}

		if ($this->special !== $v) {
			$this->special = $v;
			$this->modifiedColumns[] = ActivityPeer::SPECIAL;
		}

		return $this;
	} // setSpecial()

	/**
	 * Set the value of [position] column.
	 * 
	 * @param      int $v new value
	 * @return     Activity The current object (for fluent API support)
	 */
	public function setPosition($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->position !== $v) {
			$this->position = $v;
			$this->modifiedColumns[] = ActivityPeer::POSITION;
		}

		return $this;
	} // setPosition()

	/**
	 * Indicates whether the columns in this object are only set to default values.
	 *
	 * This method can be used in conjunction with isModified() to indicate whether an object is both
	 * modified _and_ has some values set which are non-default.
	 *
	 * @return     boolean Whether the columns in this object are only been set with default values.
	 */
	public function hasOnlyDefaultValues()
	{
		// otherwise, everything was equal, so return TRUE
		return true;
	} // hasOnlyDefaultValues()

	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (0-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param      array $row The row returned by PDOStatement->fetch(PDO::FETCH_NUM)
	 * @param      int $startcol 0-based offset column which indicates which restultset column to start with.
	 * @param      boolean $rehydrate Whether this object is being re-hydrated from the database.
	 * @return     int next starting column
	 * @throws     PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->title = ($row[$startcol + 1] !== null) ? (string) $row[$startcol + 1] : null;
			$this->content = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
			$this->is_constant = ($row[$startcol + 3] !== null) ? (boolean) $row[$startcol + 3] : null;
			$this->is_internet = ($row[$startcol + 4] !== null) ? (boolean) $row[$startcol + 4] : null;
			$this->is_sent = ($row[$startcol + 5] !== null) ? (boolean) $row[$startcol + 5] : null;
			$this->starts_at = ($row[$startcol + 6] !== null) ? (string) $row[$startcol + 6] : null;
			$this->finishes_at = ($row[$startcol + 7] !== null) ? (string) $row[$startcol + 7] : null;
			$this->created_at = ($row[$startcol + 8] !== null) ? (string) $row[$startcol + 8] : null;
			$this->delete_at = ($row[$startcol + 9] !== null) ? (string) $row[$startcol + 9] : null;
			$this->places_available = ($row[$startcol + 10] !== null) ? (int) $row[$startcol + 10] : null;
			$this->user_id = ($row[$startcol + 11] !== null) ? (int) $row[$startcol + 11] : null;
			$this->group_id = ($row[$startcol + 12] !== null) ? (int) $row[$startcol + 12] : null;
			$this->contact_person = ($row[$startcol + 13] !== null) ? (string) $row[$startcol + 13] : null;
			$this->email = ($row[$startcol + 14] !== null) ? (string) $row[$startcol + 14] : null;
			$this->phone = ($row[$startcol + 15] !== null) ? (string) $row[$startcol + 15] : null;
			$this->latitude = ($row[$startcol + 16] !== null) ? (string) $row[$startcol + 16] : null;
			$this->longitude = ($row[$startcol + 17] !== null) ? (string) $row[$startcol + 17] : null;
			$this->address = ($row[$startcol + 18] !== null) ? (string) $row[$startcol + 18] : null;
			$this->archived = ($row[$startcol + 19] !== null) ? (boolean) $row[$startcol + 19] : null;
			$this->special = ($row[$startcol + 20] !== null) ? (boolean) $row[$startcol + 20] : null;
			$this->position = ($row[$startcol + 21] !== null) ? (int) $row[$startcol + 21] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

			// FIXME - using NUM_COLUMNS may be clearer.
			return $startcol + 22; // 22 = ActivityPeer::NUM_COLUMNS - ActivityPeer::NUM_LAZY_LOAD_COLUMNS).

		} catch (Exception $e) {
			throw new PropelException("Error populating Activity object", $e);
		}
	}

	/**
	 * Checks and repairs the internal consistency of the object.
	 *
	 * This method is executed after an already-instantiated object is re-hydrated
	 * from the database.  It exists to check any foreign keys to make sure that
	 * the objects related to the current object are correct based on foreign key.
	 *
	 * You can override this method in the stub class, but you should always invoke
	 * the base method from the overridden method (i.e. parent::ensureConsistency()),
	 * in case your model changes.
	 *
	 * @throws     PropelException
	 */
	public function ensureConsistency()
	{

		if ($this->aUser !== null && $this->user_id !== $this->aUser->getId()) {
			$this->aUser = null;
		}
		if ($this->aGroupCategory !== null && $this->group_id !== $this->aGroupCategory->getId()) {
			$this->aGroupCategory = null;
		}
	} // ensureConsistency

	/**
	 * Reloads this object from datastore based on primary key and (optionally) resets all associated objects.
	 *
	 * This will only work if the object has been saved and has a valid primary key set.
	 *
	 * @param      boolean $deep (optional) Whether to also de-associated any related objects.
	 * @param      PropelPDO $con (optional) The PropelPDO connection to use.
	 * @return     void
	 * @throws     PropelException - if this object is deleted, unsaved or doesn't have pk match in db
	 */
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ActivityPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

		// We don't need to alter the object instance pool; we're just modifying this instance
		// already in the pool.

		$stmt = ActivityPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); // rehydrate

		if ($deep) {  // also de-associate any related objects?

			$this->aUser = null;
			$this->aGroupCategory = null;
			$this->collUserActivitys = null;
			$this->lastUserActivityCriteria = null;

			$this->collMeetingUsers = null;
			$this->lastMeetingUserCriteria = null;

		} // if (deep)
	}

	/**
	 * Removes this object from datastore and sets delete attribute.
	 *
	 * @param      PropelPDO $con
	 * @return     void
	 * @throws     PropelException
	 * @see        BaseObject::setDeleted()
	 * @see        BaseObject::isDeleted()
	 */
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ActivityPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$ret = $this->preDelete($con);
			// symfony_behaviors behavior
			foreach (sfMixer::getCallables('BaseActivity:delete:pre') as $callable)
			{
			  if (call_user_func($callable, $this, $con))
			  {
			    $con->commit();
			
			    return;
			  }
			}

			if ($ret) {
				ActivityPeer::doDelete($this, $con);
				$this->postDelete($con);
				// symfony_behaviors behavior
				foreach (sfMixer::getCallables('BaseActivity:delete:post') as $callable)
				{
				  call_user_func($callable, $this, $con);
				}

				$this->setDeleted(true);
				$con->commit();
			} else {
				$con->commit();
			}
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	/**
	 * Persists this object to the database.
	 *
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All modified related objects will also be persisted in the doSave()
	 * method.  This method wraps all precipitate database operations in a
	 * single transaction.
	 *
	 * @param      PropelPDO $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        doSave()
	 */
	public function save(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ActivityPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		$isInsert = $this->isNew();
		try {
			$ret = $this->preSave($con);
			// symfony_behaviors behavior
			foreach (sfMixer::getCallables('BaseActivity:save:pre') as $callable)
			{
			  if (is_integer($affectedRows = call_user_func($callable, $this, $con)))
			  {
			    $con->commit();
			
			    return $affectedRows;
			  }
			}

			// symfony_timestampable behavior
			
			if ($isInsert) {
				$ret = $ret && $this->preInsert($con);
				// symfony_timestampable behavior
				if (!$this->isColumnModified(ActivityPeer::CREATED_AT))
				{
				  $this->setCreatedAt(time());
				}

			} else {
				$ret = $ret && $this->preUpdate($con);
			}
			if ($ret) {
				$affectedRows = $this->doSave($con);
				if ($isInsert) {
					$this->postInsert($con);
				} else {
					$this->postUpdate($con);
				}
				$this->postSave($con);
				// symfony_behaviors behavior
				foreach (sfMixer::getCallables('BaseActivity:save:post') as $callable)
				{
				  call_user_func($callable, $this, $con, $affectedRows);
				}

				ActivityPeer::addInstanceToPool($this);
			} else {
				$affectedRows = 0;
			}
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	/**
	 * Performs the work of inserting or updating the row in the database.
	 *
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All related objects are also updated in this method.
	 *
	 * @param      PropelPDO $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        save()
	 */
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; // initialize var to track total num of affected rows
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aUser !== null) {
				if ($this->aUser->isModified() || $this->aUser->isNew()) {
					$affectedRows += $this->aUser->save($con);
				}
				$this->setUser($this->aUser);
			}

			if ($this->aGroupCategory !== null) {
				if ($this->aGroupCategory->isModified() || $this->aGroupCategory->isNew()) {
					$affectedRows += $this->aGroupCategory->save($con);
				}
				$this->setGroupCategory($this->aGroupCategory);
			}

			if ($this->isNew() ) {
				$this->modifiedColumns[] = ActivityPeer::ID;
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ActivityPeer::doInsert($this, $con);
					$affectedRows += 1; // we are assuming that there is only 1 row per doInsert() which
										 // should always be true here (even though technically
										 // BasePeer::doInsert() can insert multiple rows).

					$this->setId($pk);  //[IMV] update autoincrement primary key

					$this->setNew(false);
				} else {
					$affectedRows += ActivityPeer::doUpdate($this, $con);
				}

				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			if ($this->collUserActivitys !== null) {
				foreach ($this->collUserActivitys as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collMeetingUsers !== null) {
				foreach ($this->collMeetingUsers as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} // doSave()

	/**
	 * Array of ValidationFailed objects.
	 * @var        array ValidationFailed[]
	 */
	protected $validationFailures = array();

	/**
	 * Gets any ValidationFailed objects that resulted from last call to validate().
	 *
	 *
	 * @return     array ValidationFailed[]
	 * @see        validate()
	 */
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	/**
	 * Validates the objects modified field values and all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param      mixed $columns Column name or an array of column names.
	 * @return     boolean Whether all columns pass validation.
	 * @see        doValidate()
	 * @see        getValidationFailures()
	 */
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	/**
	 * This function performs the validation work for complex object models.
	 *
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @param      array $columns Array of column names to validate.
	 * @return     mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aUser !== null) {
				if (!$this->aUser->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aUser->getValidationFailures());
				}
			}

			if ($this->aGroupCategory !== null) {
				if (!$this->aGroupCategory->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aGroupCategory->getValidationFailures());
				}
			}


			if (($retval = ActivityPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collUserActivitys !== null) {
					foreach ($this->collUserActivitys as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collMeetingUsers !== null) {
					foreach ($this->collMeetingUsers as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	/**
	 * Retrieves a field from the object by name passed in as a string.
	 *
	 * @param      string $name name
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
	 * @return     mixed Value of field.
	 */
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ActivityPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @return     mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getTitle();
				break;
			case 2:
				return $this->getContent();
				break;
			case 3:
				return $this->getIsConstant();
				break;
			case 4:
				return $this->getIsInternet();
				break;
			case 5:
				return $this->getIsSent();
				break;
			case 6:
				return $this->getStartsAt();
				break;
			case 7:
				return $this->getFinishesAt();
				break;
			case 8:
				return $this->getCreatedAt();
				break;
			case 9:
				return $this->getDeleteAt();
				break;
			case 10:
				return $this->getPlacesAvailable();
				break;
			case 11:
				return $this->getUserId();
				break;
			case 12:
				return $this->getGroupId();
				break;
			case 13:
				return $this->getContactPerson();
				break;
			case 14:
				return $this->getEmail();
				break;
			case 15:
				return $this->getPhone();
				break;
			case 16:
				return $this->getLatitude();
				break;
			case 17:
				return $this->getLongitude();
				break;
			case 18:
				return $this->getAddress();
				break;
			case 19:
				return $this->getArchived();
				break;
			case 20:
				return $this->getSpecial();
				break;
			case 21:
				return $this->getPosition();
				break;
			default:
				return null;
				break;
		} // switch()
	}

	/**
	 * Exports the object as an array.
	 *
	 * You can specify the key type of the array by passing one of the class
	 * type constants.
	 *
	 * @param      string $keyType (optional) One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                        BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM. Defaults to BasePeer::TYPE_PHPNAME.
	 * @param      boolean $includeLazyLoadColumns (optional) Whether to include lazy loaded columns.  Defaults to TRUE.
	 * @return     an associative array containing the field names (as keys) and field values
	 */
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = ActivityPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getTitle(),
			$keys[2] => $this->getContent(),
			$keys[3] => $this->getIsConstant(),
			$keys[4] => $this->getIsInternet(),
			$keys[5] => $this->getIsSent(),
			$keys[6] => $this->getStartsAt(),
			$keys[7] => $this->getFinishesAt(),
			$keys[8] => $this->getCreatedAt(),
			$keys[9] => $this->getDeleteAt(),
			$keys[10] => $this->getPlacesAvailable(),
			$keys[11] => $this->getUserId(),
			$keys[12] => $this->getGroupId(),
			$keys[13] => $this->getContactPerson(),
			$keys[14] => $this->getEmail(),
			$keys[15] => $this->getPhone(),
			$keys[16] => $this->getLatitude(),
			$keys[17] => $this->getLongitude(),
			$keys[18] => $this->getAddress(),
			$keys[19] => $this->getArchived(),
			$keys[20] => $this->getSpecial(),
			$keys[21] => $this->getPosition(),
		);
		return $result;
	}

	/**
	 * Sets a field from the object by name passed in as a string.
	 *
	 * @param      string $name peer name
	 * @param      mixed $value field value
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
	 * @return     void
	 */
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ActivityPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @param      mixed $value field value
	 * @return     void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setTitle($value);
				break;
			case 2:
				$this->setContent($value);
				break;
			case 3:
				$this->setIsConstant($value);
				break;
			case 4:
				$this->setIsInternet($value);
				break;
			case 5:
				$this->setIsSent($value);
				break;
			case 6:
				$this->setStartsAt($value);
				break;
			case 7:
				$this->setFinishesAt($value);
				break;
			case 8:
				$this->setCreatedAt($value);
				break;
			case 9:
				$this->setDeleteAt($value);
				break;
			case 10:
				$this->setPlacesAvailable($value);
				break;
			case 11:
				$this->setUserId($value);
				break;
			case 12:
				$this->setGroupId($value);
				break;
			case 13:
				$this->setContactPerson($value);
				break;
			case 14:
				$this->setEmail($value);
				break;
			case 15:
				$this->setPhone($value);
				break;
			case 16:
				$this->setLatitude($value);
				break;
			case 17:
				$this->setLongitude($value);
				break;
			case 18:
				$this->setAddress($value);
				break;
			case 19:
				$this->setArchived($value);
				break;
			case 20:
				$this->setSpecial($value);
				break;
			case 21:
				$this->setPosition($value);
				break;
		} // switch()
	}

	/**
	 * Populates the object using an array.
	 *
	 * This is particularly useful when populating an object from one of the
	 * request arrays (e.g. $_POST).  This method goes through the column
	 * names, checking to see whether a matching key exists in populated
	 * array. If so the setByName() method is called for that column.
	 *
	 * You can specify the key type of the array by additionally passing one
	 * of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME,
	 * BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
	 * The default key type is the column's phpname (e.g. 'AuthorId')
	 *
	 * @param      array  $arr     An array to populate the object from.
	 * @param      string $keyType The type of keys the array uses.
	 * @return     void
	 */
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ActivityPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setTitle($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setContent($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setIsConstant($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setIsInternet($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setIsSent($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setStartsAt($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setFinishesAt($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setCreatedAt($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setDeleteAt($arr[$keys[9]]);
		if (array_key_exists($keys[10], $arr)) $this->setPlacesAvailable($arr[$keys[10]]);
		if (array_key_exists($keys[11], $arr)) $this->setUserId($arr[$keys[11]]);
		if (array_key_exists($keys[12], $arr)) $this->setGroupId($arr[$keys[12]]);
		if (array_key_exists($keys[13], $arr)) $this->setContactPerson($arr[$keys[13]]);
		if (array_key_exists($keys[14], $arr)) $this->setEmail($arr[$keys[14]]);
		if (array_key_exists($keys[15], $arr)) $this->setPhone($arr[$keys[15]]);
		if (array_key_exists($keys[16], $arr)) $this->setLatitude($arr[$keys[16]]);
		if (array_key_exists($keys[17], $arr)) $this->setLongitude($arr[$keys[17]]);
		if (array_key_exists($keys[18], $arr)) $this->setAddress($arr[$keys[18]]);
		if (array_key_exists($keys[19], $arr)) $this->setArchived($arr[$keys[19]]);
		if (array_key_exists($keys[20], $arr)) $this->setSpecial($arr[$keys[20]]);
		if (array_key_exists($keys[21], $arr)) $this->setPosition($arr[$keys[21]]);
	}

	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return     Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{
		$criteria = new Criteria(ActivityPeer::DATABASE_NAME);

		if ($this->isColumnModified(ActivityPeer::ID)) $criteria->add(ActivityPeer::ID, $this->id);
		if ($this->isColumnModified(ActivityPeer::TITLE)) $criteria->add(ActivityPeer::TITLE, $this->title);
		if ($this->isColumnModified(ActivityPeer::CONTENT)) $criteria->add(ActivityPeer::CONTENT, $this->content);
		if ($this->isColumnModified(ActivityPeer::IS_CONSTANT)) $criteria->add(ActivityPeer::IS_CONSTANT, $this->is_constant);
		if ($this->isColumnModified(ActivityPeer::IS_INTERNET)) $criteria->add(ActivityPeer::IS_INTERNET, $this->is_internet);
		if ($this->isColumnModified(ActivityPeer::IS_SENT)) $criteria->add(ActivityPeer::IS_SENT, $this->is_sent);
		if ($this->isColumnModified(ActivityPeer::STARTS_AT)) $criteria->add(ActivityPeer::STARTS_AT, $this->starts_at);
		if ($this->isColumnModified(ActivityPeer::FINISHES_AT)) $criteria->add(ActivityPeer::FINISHES_AT, $this->finishes_at);
		if ($this->isColumnModified(ActivityPeer::CREATED_AT)) $criteria->add(ActivityPeer::CREATED_AT, $this->created_at);
		if ($this->isColumnModified(ActivityPeer::DELETE_AT)) $criteria->add(ActivityPeer::DELETE_AT, $this->delete_at);
		if ($this->isColumnModified(ActivityPeer::PLACES_AVAILABLE)) $criteria->add(ActivityPeer::PLACES_AVAILABLE, $this->places_available);
		if ($this->isColumnModified(ActivityPeer::USER_ID)) $criteria->add(ActivityPeer::USER_ID, $this->user_id);
		if ($this->isColumnModified(ActivityPeer::GROUP_ID)) $criteria->add(ActivityPeer::GROUP_ID, $this->group_id);
		if ($this->isColumnModified(ActivityPeer::CONTACT_PERSON)) $criteria->add(ActivityPeer::CONTACT_PERSON, $this->contact_person);
		if ($this->isColumnModified(ActivityPeer::EMAIL)) $criteria->add(ActivityPeer::EMAIL, $this->email);
		if ($this->isColumnModified(ActivityPeer::PHONE)) $criteria->add(ActivityPeer::PHONE, $this->phone);
		if ($this->isColumnModified(ActivityPeer::LATITUDE)) $criteria->add(ActivityPeer::LATITUDE, $this->latitude);
		if ($this->isColumnModified(ActivityPeer::LONGITUDE)) $criteria->add(ActivityPeer::LONGITUDE, $this->longitude);
		if ($this->isColumnModified(ActivityPeer::ADDRESS)) $criteria->add(ActivityPeer::ADDRESS, $this->address);
		if ($this->isColumnModified(ActivityPeer::ARCHIVED)) $criteria->add(ActivityPeer::ARCHIVED, $this->archived);
		if ($this->isColumnModified(ActivityPeer::SPECIAL)) $criteria->add(ActivityPeer::SPECIAL, $this->special);
		if ($this->isColumnModified(ActivityPeer::POSITION)) $criteria->add(ActivityPeer::POSITION, $this->position);

		return $criteria;
	}

	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 *
	 * @return     Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(ActivityPeer::DATABASE_NAME);

		$criteria->add(ActivityPeer::ID, $this->id);

		return $criteria;
	}

	/**
	 * Returns the primary key for this object (row).
	 * @return     int
	 */
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	/**
	 * Generic method to set the primary key (id column).
	 *
	 * @param      int $key Primary key.
	 * @return     void
	 */
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	/**
	 * Sets contents of passed object to values from current object.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      object $copyObj An object of Activity (or compatible) type.
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @throws     PropelException
	 */
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setTitle($this->title);

		$copyObj->setContent($this->content);

		$copyObj->setIsConstant($this->is_constant);

		$copyObj->setIsInternet($this->is_internet);

		$copyObj->setIsSent($this->is_sent);

		$copyObj->setStartsAt($this->starts_at);

		$copyObj->setFinishesAt($this->finishes_at);

		$copyObj->setCreatedAt($this->created_at);

		$copyObj->setDeleteAt($this->delete_at);

		$copyObj->setPlacesAvailable($this->places_available);

		$copyObj->setUserId($this->user_id);

		$copyObj->setGroupId($this->group_id);

		$copyObj->setContactPerson($this->contact_person);

		$copyObj->setEmail($this->email);

		$copyObj->setPhone($this->phone);

		$copyObj->setLatitude($this->latitude);

		$copyObj->setLongitude($this->longitude);

		$copyObj->setAddress($this->address);

		$copyObj->setArchived($this->archived);

		$copyObj->setSpecial($this->special);

		$copyObj->setPosition($this->position);


		if ($deepCopy) {
			// important: temporarily setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach ($this->getUserActivitys() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addUserActivity($relObj->copy($deepCopy));
				}
			}

			foreach ($this->getMeetingUsers() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addMeetingUser($relObj->copy($deepCopy));
				}
			}

		} // if ($deepCopy)


		$copyObj->setNew(true);

		$copyObj->setId(NULL); // this is a auto-increment column, so set to default value

	}

	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @return     Activity Clone of current object.
	 * @throws     PropelException
	 */
	public function copy($deepCopy = false)
	{
		// we use get_class(), because this might be a subclass
		$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	/**
	 * Returns a peer instance associated with this om.
	 *
	 * Since Peer classes are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 *
	 * @return     ActivityPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ActivityPeer();
		}
		return self::$peer;
	}

	/**
	 * Declares an association between this object and a User object.
	 *
	 * @param      User $v
	 * @return     Activity The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setUser(User $v = null)
	{
		if ($v === null) {
			$this->setUserId(NULL);
		} else {
			$this->setUserId($v->getId());
		}

		$this->aUser = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the User object, it will not be re-added.
		if ($v !== null) {
			$v->addActivity($this);
		}

		return $this;
	}


	/**
	 * Get the associated User object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     User The associated User object.
	 * @throws     PropelException
	 */
	public function getUser(PropelPDO $con = null)
	{
		if ($this->aUser === null && ($this->user_id !== null)) {
			$this->aUser = UserPeer::retrieveByPk($this->user_id);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aUser->addActivitys($this);
			 */
		}
		return $this->aUser;
	}

	/**
	 * Declares an association between this object and a GroupCategory object.
	 *
	 * @param      GroupCategory $v
	 * @return     Activity The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setGroupCategory(GroupCategory $v = null)
	{
		if ($v === null) {
			$this->setGroupId(NULL);
		} else {
			$this->setGroupId($v->getId());
		}

		$this->aGroupCategory = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the GroupCategory object, it will not be re-added.
		if ($v !== null) {
			$v->addActivity($this);
		}

		return $this;
	}


	/**
	 * Get the associated GroupCategory object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     GroupCategory The associated GroupCategory object.
	 * @throws     PropelException
	 */
	public function getGroupCategory(PropelPDO $con = null)
	{
		if ($this->aGroupCategory === null && ($this->group_id !== null)) {
			$this->aGroupCategory = GroupCategoryPeer::retrieveByPk($this->group_id);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aGroupCategory->addActivitys($this);
			 */
		}
		return $this->aGroupCategory;
	}

	/**
	 * Clears out the collUserActivitys collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addUserActivitys()
	 */
	public function clearUserActivitys()
	{
		$this->collUserActivitys = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collUserActivitys collection (array).
	 *
	 * By default this just sets the collUserActivitys collection to an empty array (like clearcollUserActivitys());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initUserActivitys()
	{
		$this->collUserActivitys = array();
	}

	/**
	 * Gets an array of UserActivity objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Activity has previously been saved, it will retrieve
	 * related UserActivitys from storage. If this Activity is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array UserActivity[]
	 * @throws     PropelException
	 */
	public function getUserActivitys($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ActivityPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collUserActivitys === null) {
			if ($this->isNew()) {
			   $this->collUserActivitys = array();
			} else {

				$criteria->add(UserActivityPeer::ACTIVITY_ID, $this->id);

				UserActivityPeer::addSelectColumns($criteria);
				$this->collUserActivitys = UserActivityPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(UserActivityPeer::ACTIVITY_ID, $this->id);

				UserActivityPeer::addSelectColumns($criteria);
				if (!isset($this->lastUserActivityCriteria) || !$this->lastUserActivityCriteria->equals($criteria)) {
					$this->collUserActivitys = UserActivityPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastUserActivityCriteria = $criteria;
		return $this->collUserActivitys;
	}

	/**
	 * Returns the number of related UserActivity objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related UserActivity objects.
	 * @throws     PropelException
	 */
	public function countUserActivitys(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ActivityPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collUserActivitys === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(UserActivityPeer::ACTIVITY_ID, $this->id);

				$count = UserActivityPeer::doCount($criteria, false, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(UserActivityPeer::ACTIVITY_ID, $this->id);

				if (!isset($this->lastUserActivityCriteria) || !$this->lastUserActivityCriteria->equals($criteria)) {
					$count = UserActivityPeer::doCount($criteria, false, $con);
				} else {
					$count = count($this->collUserActivitys);
				}
			} else {
				$count = count($this->collUserActivitys);
			}
		}
		return $count;
	}

	/**
	 * Method called to associate a UserActivity object to this object
	 * through the UserActivity foreign key attribute.
	 *
	 * @param      UserActivity $l UserActivity
	 * @return     void
	 * @throws     PropelException
	 */
	public function addUserActivity(UserActivity $l)
	{
		if ($this->collUserActivitys === null) {
			$this->initUserActivitys();
		}
		if (!in_array($l, $this->collUserActivitys, true)) { // only add it if the **same** object is not already associated
			array_push($this->collUserActivitys, $l);
			$l->setActivity($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Activity is new, it will return
	 * an empty collection; or if this Activity has previously
	 * been saved, it will retrieve related UserActivitys from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Activity.
	 */
	public function getUserActivitysJoinUser($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ActivityPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collUserActivitys === null) {
			if ($this->isNew()) {
				$this->collUserActivitys = array();
			} else {

				$criteria->add(UserActivityPeer::ACTIVITY_ID, $this->id);

				$this->collUserActivitys = UserActivityPeer::doSelectJoinUser($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(UserActivityPeer::ACTIVITY_ID, $this->id);

			if (!isset($this->lastUserActivityCriteria) || !$this->lastUserActivityCriteria->equals($criteria)) {
				$this->collUserActivitys = UserActivityPeer::doSelectJoinUser($criteria, $con, $join_behavior);
			}
		}
		$this->lastUserActivityCriteria = $criteria;

		return $this->collUserActivitys;
	}

	/**
	 * Clears out the collMeetingUsers collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addMeetingUsers()
	 */
	public function clearMeetingUsers()
	{
		$this->collMeetingUsers = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collMeetingUsers collection (array).
	 *
	 * By default this just sets the collMeetingUsers collection to an empty array (like clearcollMeetingUsers());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initMeetingUsers()
	{
		$this->collMeetingUsers = array();
	}

	/**
	 * Gets an array of MeetingUser objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Activity has previously been saved, it will retrieve
	 * related MeetingUsers from storage. If this Activity is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array MeetingUser[]
	 * @throws     PropelException
	 */
	public function getMeetingUsers($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ActivityPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collMeetingUsers === null) {
			if ($this->isNew()) {
			   $this->collMeetingUsers = array();
			} else {

				$criteria->add(MeetingUserPeer::ACTIVITY_ID, $this->id);

				MeetingUserPeer::addSelectColumns($criteria);
				$this->collMeetingUsers = MeetingUserPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(MeetingUserPeer::ACTIVITY_ID, $this->id);

				MeetingUserPeer::addSelectColumns($criteria);
				if (!isset($this->lastMeetingUserCriteria) || !$this->lastMeetingUserCriteria->equals($criteria)) {
					$this->collMeetingUsers = MeetingUserPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastMeetingUserCriteria = $criteria;
		return $this->collMeetingUsers;
	}

	/**
	 * Returns the number of related MeetingUser objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related MeetingUser objects.
	 * @throws     PropelException
	 */
	public function countMeetingUsers(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ActivityPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collMeetingUsers === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(MeetingUserPeer::ACTIVITY_ID, $this->id);

				$count = MeetingUserPeer::doCount($criteria, false, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(MeetingUserPeer::ACTIVITY_ID, $this->id);

				if (!isset($this->lastMeetingUserCriteria) || !$this->lastMeetingUserCriteria->equals($criteria)) {
					$count = MeetingUserPeer::doCount($criteria, false, $con);
				} else {
					$count = count($this->collMeetingUsers);
				}
			} else {
				$count = count($this->collMeetingUsers);
			}
		}
		return $count;
	}

	/**
	 * Method called to associate a MeetingUser object to this object
	 * through the MeetingUser foreign key attribute.
	 *
	 * @param      MeetingUser $l MeetingUser
	 * @return     void
	 * @throws     PropelException
	 */
	public function addMeetingUser(MeetingUser $l)
	{
		if ($this->collMeetingUsers === null) {
			$this->initMeetingUsers();
		}
		if (!in_array($l, $this->collMeetingUsers, true)) { // only add it if the **same** object is not already associated
			array_push($this->collMeetingUsers, $l);
			$l->setActivity($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Activity is new, it will return
	 * an empty collection; or if this Activity has previously
	 * been saved, it will retrieve related MeetingUsers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Activity.
	 */
	public function getMeetingUsersJoinMeeting($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(ActivityPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collMeetingUsers === null) {
			if ($this->isNew()) {
				$this->collMeetingUsers = array();
			} else {

				$criteria->add(MeetingUserPeer::ACTIVITY_ID, $this->id);

				$this->collMeetingUsers = MeetingUserPeer::doSelectJoinMeeting($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(MeetingUserPeer::ACTIVITY_ID, $this->id);

			if (!isset($this->lastMeetingUserCriteria) || !$this->lastMeetingUserCriteria->equals($criteria)) {
				$this->collMeetingUsers = MeetingUserPeer::doSelectJoinMeeting($criteria, $con, $join_behavior);
			}
		}
		$this->lastMeetingUserCriteria = $criteria;

		return $this->collMeetingUsers;
	}

	/**
	 * Resets all collections of referencing foreign keys.
	 *
	 * This method is a user-space workaround for PHP's inability to garbage collect objects
	 * with circular references.  This is currently necessary when using Propel in certain
	 * daemon or large-volumne/high-memory operations.
	 *
	 * @param      boolean $deep Whether to also clear the references on all associated objects.
	 */
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
			if ($this->collUserActivitys) {
				foreach ((array) $this->collUserActivitys as $o) {
					$o->clearAllReferences($deep);
				}
			}
			if ($this->collMeetingUsers) {
				foreach ((array) $this->collMeetingUsers as $o) {
					$o->clearAllReferences($deep);
				}
			}
		} // if ($deep)

		$this->collUserActivitys = null;
		$this->collMeetingUsers = null;
			$this->aUser = null;
			$this->aGroupCategory = null;
	}

	// symfony_behaviors behavior
	
	/**
	 * Calls methods defined via {@link sfMixer}.
	 */
	public function __call($method, $arguments)
	{
	  if (!$callable = sfMixer::getCallable('BaseActivity:'.$method))
	  {
	    throw new sfException(sprintf('Call to undefined method BaseActivity::%s', $method));
	  }
	
	  array_unshift($arguments, $this);
	
	  return call_user_func_array($callable, $arguments);
	}

} // BaseActivity
