<?php

/**
 * Base class that represents a row from the 'foundation' table.
 *
 * 
 *
 * This class was autogenerated by Propel 1.4.2 on:
 *
 * 11/11/16 11:30:14
 *
 * @package    lib.model.om
 */
abstract class BaseFoundation extends BaseObject  implements Persistent {


	/**
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var        FoundationPeer
	 */
	protected static $peer;

	/**
	 * The value for the id field.
	 * @var        int
	 */
	protected $id;

	/**
	 * The value for the user_id field.
	 * @var        int
	 */
	protected $user_id;

	/**
	 * The value for the logo field.
	 * @var        string
	 */
	protected $logo;

	/**
	 * The value for the content field.
	 * @var        string
	 */
	protected $content;

	/**
	 * The value for the contact_person field.
	 * @var        string
	 */
	protected $contact_person;

	/**
	 * The value for the latitude field.
	 * @var        string
	 */
	protected $latitude;

	/**
	 * The value for the longitude field.
	 * @var        string
	 */
	protected $longitude;

	/**
	 * The value for the address field.
	 * @var        string
	 */
	protected $address;

	/**
	 * The value for the district_id field.
	 * Note: this column has a database default value of: 1
	 * @var        int
	 */
	protected $district_id;

	/**
	 * The value for the phone field.
	 * @var        string
	 */
	protected $phone;

	/**
	 * The value for the www field.
	 * @var        string
	 */
	protected $www;

	/**
	 * The value for the area0 field.
	 * @var        boolean
	 */
	protected $area0;

	/**
	 * The value for the area1 field.
	 * @var        boolean
	 */
	protected $area1;

	/**
	 * The value for the area2 field.
	 * @var        boolean
	 */
	protected $area2;

	/**
	 * The value for the area3 field.
	 * @var        boolean
	 */
	protected $area3;

	/**
	 * The value for the area4 field.
	 * @var        boolean
	 */
	protected $area4;

	/**
	 * The value for the area5 field.
	 * @var        boolean
	 */
	protected $area5;

	/**
	 * The value for the area6 field.
	 * @var        boolean
	 */
	protected $area6;

	/**
	 * The value for the active field.
	 * Note: this column has a database default value of: true
	 * @var        boolean
	 */
	protected $active;

	/**
	 * @var        User
	 */
	protected $aUser;

	/**
	 * @var        District
	 */
	protected $aDistrict;

	/**
	 * @var        array FoundationImage[] Collection to store aggregation of FoundationImage objects.
	 */
	protected $collFoundationImages;

	/**
	 * @var        Criteria The criteria used to select the current contents of collFoundationImages.
	 */
	private $lastFoundationImageCriteria = null;

	/**
	 * Flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInSave = false;

	/**
	 * Flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInValidation = false;

	// symfony behavior
	
	const PEER = 'FoundationPeer';

	/**
	 * Applies default values to this object.
	 * This method should be called from the object's constructor (or
	 * equivalent initialization method).
	 * @see        __construct()
	 */
	public function applyDefaultValues()
	{
		$this->district_id = 1;
		$this->active = true;
	}

	/**
	 * Initializes internal state of BaseFoundation object.
	 * @see        applyDefaults()
	 */
	public function __construct()
	{
		parent::__construct();
		$this->applyDefaultValues();
	}

	/**
	 * Get the [id] column value.
	 * 
	 * @return     int
	 */
	public function getId()
	{
		return $this->id;
	}

	/**
	 * Get the [user_id] column value.
	 * 
	 * @return     int
	 */
	public function getUserId()
	{
		return $this->user_id;
	}

	/**
	 * Get the [logo] column value.
	 * 
	 * @return     string
	 */
	public function getLogo()
	{
		return $this->logo;
	}

	/**
	 * Get the [content] column value.
	 * 
	 * @return     string
	 */
	public function getContent()
	{
		return $this->content;
	}

	/**
	 * Get the [contact_person] column value.
	 * 
	 * @return     string
	 */
	public function getContactPerson()
	{
		return $this->contact_person;
	}

	/**
	 * Get the [latitude] column value.
	 * 
	 * @return     string
	 */
	public function getLatitude()
	{
		return $this->latitude;
	}

	/**
	 * Get the [longitude] column value.
	 * 
	 * @return     string
	 */
	public function getLongitude()
	{
		return $this->longitude;
	}

	/**
	 * Get the [address] column value.
	 * 
	 * @return     string
	 */
	public function getAddress()
	{
		return $this->address;
	}

	/**
	 * Get the [district_id] column value.
	 * 
	 * @return     int
	 */
	public function getDistrictId()
	{
		return $this->district_id;
	}

	/**
	 * Get the [phone] column value.
	 * 
	 * @return     string
	 */
	public function getPhone()
	{
		return $this->phone;
	}

	/**
	 * Get the [www] column value.
	 * 
	 * @return     string
	 */
	public function getWww()
	{
		return $this->www;
	}

	/**
	 * Get the [area0] column value.
	 * 
	 * @return     boolean
	 */
	public function getArea0()
	{
		return $this->area0;
	}

	/**
	 * Get the [area1] column value.
	 * 
	 * @return     boolean
	 */
	public function getArea1()
	{
		return $this->area1;
	}

	/**
	 * Get the [area2] column value.
	 * 
	 * @return     boolean
	 */
	public function getArea2()
	{
		return $this->area2;
	}

	/**
	 * Get the [area3] column value.
	 * 
	 * @return     boolean
	 */
	public function getArea3()
	{
		return $this->area3;
	}

	/**
	 * Get the [area4] column value.
	 * 
	 * @return     boolean
	 */
	public function getArea4()
	{
		return $this->area4;
	}

	/**
	 * Get the [area5] column value.
	 * 
	 * @return     boolean
	 */
	public function getArea5()
	{
		return $this->area5;
	}

	/**
	 * Get the [area6] column value.
	 * 
	 * @return     boolean
	 */
	public function getArea6()
	{
		return $this->area6;
	}

	/**
	 * Get the [active] column value.
	 * 
	 * @return     boolean
	 */
	public function getActive()
	{
		return $this->active;
	}

	/**
	 * Set the value of [id] column.
	 * 
	 * @param      int $v new value
	 * @return     Foundation The current object (for fluent API support)
	 */
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = FoundationPeer::ID;
		}

		return $this;
	} // setId()

	/**
	 * Set the value of [user_id] column.
	 * 
	 * @param      int $v new value
	 * @return     Foundation The current object (for fluent API support)
	 */
	public function setUserId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->user_id !== $v) {
			$this->user_id = $v;
			$this->modifiedColumns[] = FoundationPeer::USER_ID;
		}

		if ($this->aUser !== null && $this->aUser->getId() !== $v) {
			$this->aUser = null;
		}

		return $this;
	} // setUserId()

	/**
	 * Set the value of [logo] column.
	 * 
	 * @param      string $v new value
	 * @return     Foundation The current object (for fluent API support)
	 */
	public function setLogo($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->logo !== $v) {
			$this->logo = $v;
			$this->modifiedColumns[] = FoundationPeer::LOGO;
		}

		return $this;
	} // setLogo()

	/**
	 * Set the value of [content] column.
	 * 
	 * @param      string $v new value
	 * @return     Foundation The current object (for fluent API support)
	 */
	public function setContent($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->content !== $v) {
			$this->content = $v;
			$this->modifiedColumns[] = FoundationPeer::CONTENT;
		}

		return $this;
	} // setContent()

	/**
	 * Set the value of [contact_person] column.
	 * 
	 * @param      string $v new value
	 * @return     Foundation The current object (for fluent API support)
	 */
	public function setContactPerson($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->contact_person !== $v) {
			$this->contact_person = $v;
			$this->modifiedColumns[] = FoundationPeer::CONTACT_PERSON;
		}

		return $this;
	} // setContactPerson()

	/**
	 * Set the value of [latitude] column.
	 * 
	 * @param      string $v new value
	 * @return     Foundation The current object (for fluent API support)
	 */
	public function setLatitude($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->latitude !== $v) {
			$this->latitude = $v;
			$this->modifiedColumns[] = FoundationPeer::LATITUDE;
		}

		return $this;
	} // setLatitude()

	/**
	 * Set the value of [longitude] column.
	 * 
	 * @param      string $v new value
	 * @return     Foundation The current object (for fluent API support)
	 */
	public function setLongitude($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->longitude !== $v) {
			$this->longitude = $v;
			$this->modifiedColumns[] = FoundationPeer::LONGITUDE;
		}

		return $this;
	} // setLongitude()

	/**
	 * Set the value of [address] column.
	 * 
	 * @param      string $v new value
	 * @return     Foundation The current object (for fluent API support)
	 */
	public function setAddress($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->address !== $v) {
			$this->address = $v;
			$this->modifiedColumns[] = FoundationPeer::ADDRESS;
		}

		return $this;
	} // setAddress()

	/**
	 * Set the value of [district_id] column.
	 * 
	 * @param      int $v new value
	 * @return     Foundation The current object (for fluent API support)
	 */
	public function setDistrictId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->district_id !== $v || $this->isNew()) {
			$this->district_id = $v;
			$this->modifiedColumns[] = FoundationPeer::DISTRICT_ID;
		}

		if ($this->aDistrict !== null && $this->aDistrict->getId() !== $v) {
			$this->aDistrict = null;
		}

		return $this;
	} // setDistrictId()

	/**
	 * Set the value of [phone] column.
	 * 
	 * @param      string $v new value
	 * @return     Foundation The current object (for fluent API support)
	 */
	public function setPhone($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->phone !== $v) {
			$this->phone = $v;
			$this->modifiedColumns[] = FoundationPeer::PHONE;
		}

		return $this;
	} // setPhone()

	/**
	 * Set the value of [www] column.
	 * 
	 * @param      string $v new value
	 * @return     Foundation The current object (for fluent API support)
	 */
	public function setWww($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->www !== $v) {
			$this->www = $v;
			$this->modifiedColumns[] = FoundationPeer::WWW;
		}

		return $this;
	} // setWww()

	/**
	 * Set the value of [area0] column.
	 * 
	 * @param      boolean $v new value
	 * @return     Foundation The current object (for fluent API support)
	 */
	public function setArea0($v)
	{
		if ($v !== null) {
			$v = (boolean) $v;
		}

		if ($this->area0 !== $v) {
			$this->area0 = $v;
			$this->modifiedColumns[] = FoundationPeer::AREA0;
		}

		return $this;
	} // setArea0()

	/**
	 * Set the value of [area1] column.
	 * 
	 * @param      boolean $v new value
	 * @return     Foundation The current object (for fluent API support)
	 */
	public function setArea1($v)
	{
		if ($v !== null) {
			$v = (boolean) $v;
		}

		if ($this->area1 !== $v) {
			$this->area1 = $v;
			$this->modifiedColumns[] = FoundationPeer::AREA1;
		}

		return $this;
	} // setArea1()

	/**
	 * Set the value of [area2] column.
	 * 
	 * @param      boolean $v new value
	 * @return     Foundation The current object (for fluent API support)
	 */
	public function setArea2($v)
	{
		if ($v !== null) {
			$v = (boolean) $v;
		}

		if ($this->area2 !== $v) {
			$this->area2 = $v;
			$this->modifiedColumns[] = FoundationPeer::AREA2;
		}

		return $this;
	} // setArea2()

	/**
	 * Set the value of [area3] column.
	 * 
	 * @param      boolean $v new value
	 * @return     Foundation The current object (for fluent API support)
	 */
	public function setArea3($v)
	{
		if ($v !== null) {
			$v = (boolean) $v;
		}

		if ($this->area3 !== $v) {
			$this->area3 = $v;
			$this->modifiedColumns[] = FoundationPeer::AREA3;
		}

		return $this;
	} // setArea3()

	/**
	 * Set the value of [area4] column.
	 * 
	 * @param      boolean $v new value
	 * @return     Foundation The current object (for fluent API support)
	 */
	public function setArea4($v)
	{
		if ($v !== null) {
			$v = (boolean) $v;
		}

		if ($this->area4 !== $v) {
			$this->area4 = $v;
			$this->modifiedColumns[] = FoundationPeer::AREA4;
		}

		return $this;
	} // setArea4()

	/**
	 * Set the value of [area5] column.
	 * 
	 * @param      boolean $v new value
	 * @return     Foundation The current object (for fluent API support)
	 */
	public function setArea5($v)
	{
		if ($v !== null) {
			$v = (boolean) $v;
		}

		if ($this->area5 !== $v) {
			$this->area5 = $v;
			$this->modifiedColumns[] = FoundationPeer::AREA5;
		}

		return $this;
	} // setArea5()

	/**
	 * Set the value of [area6] column.
	 * 
	 * @param      boolean $v new value
	 * @return     Foundation The current object (for fluent API support)
	 */
	public function setArea6($v)
	{
		if ($v !== null) {
			$v = (boolean) $v;
		}

		if ($this->area6 !== $v) {
			$this->area6 = $v;
			$this->modifiedColumns[] = FoundationPeer::AREA6;
		}

		return $this;
	} // setArea6()

	/**
	 * Set the value of [active] column.
	 * 
	 * @param      boolean $v new value
	 * @return     Foundation The current object (for fluent API support)
	 */
	public function setActive($v)
	{
		if ($v !== null) {
			$v = (boolean) $v;
		}

		if ($this->active !== $v || $this->isNew()) {
			$this->active = $v;
			$this->modifiedColumns[] = FoundationPeer::ACTIVE;
		}

		return $this;
	} // setActive()

	/**
	 * Indicates whether the columns in this object are only set to default values.
	 *
	 * This method can be used in conjunction with isModified() to indicate whether an object is both
	 * modified _and_ has some values set which are non-default.
	 *
	 * @return     boolean Whether the columns in this object are only been set with default values.
	 */
	public function hasOnlyDefaultValues()
	{
			if ($this->district_id !== 1) {
				return false;
			}

			if ($this->active !== true) {
				return false;
			}

		// otherwise, everything was equal, so return TRUE
		return true;
	} // hasOnlyDefaultValues()

	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (0-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param      array $row The row returned by PDOStatement->fetch(PDO::FETCH_NUM)
	 * @param      int $startcol 0-based offset column which indicates which restultset column to start with.
	 * @param      boolean $rehydrate Whether this object is being re-hydrated from the database.
	 * @return     int next starting column
	 * @throws     PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->user_id = ($row[$startcol + 1] !== null) ? (int) $row[$startcol + 1] : null;
			$this->logo = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
			$this->content = ($row[$startcol + 3] !== null) ? (string) $row[$startcol + 3] : null;
			$this->contact_person = ($row[$startcol + 4] !== null) ? (string) $row[$startcol + 4] : null;
			$this->latitude = ($row[$startcol + 5] !== null) ? (string) $row[$startcol + 5] : null;
			$this->longitude = ($row[$startcol + 6] !== null) ? (string) $row[$startcol + 6] : null;
			$this->address = ($row[$startcol + 7] !== null) ? (string) $row[$startcol + 7] : null;
			$this->district_id = ($row[$startcol + 8] !== null) ? (int) $row[$startcol + 8] : null;
			$this->phone = ($row[$startcol + 9] !== null) ? (string) $row[$startcol + 9] : null;
			$this->www = ($row[$startcol + 10] !== null) ? (string) $row[$startcol + 10] : null;
			$this->area0 = ($row[$startcol + 11] !== null) ? (boolean) $row[$startcol + 11] : null;
			$this->area1 = ($row[$startcol + 12] !== null) ? (boolean) $row[$startcol + 12] : null;
			$this->area2 = ($row[$startcol + 13] !== null) ? (boolean) $row[$startcol + 13] : null;
			$this->area3 = ($row[$startcol + 14] !== null) ? (boolean) $row[$startcol + 14] : null;
			$this->area4 = ($row[$startcol + 15] !== null) ? (boolean) $row[$startcol + 15] : null;
			$this->area5 = ($row[$startcol + 16] !== null) ? (boolean) $row[$startcol + 16] : null;
			$this->area6 = ($row[$startcol + 17] !== null) ? (boolean) $row[$startcol + 17] : null;
			$this->active = ($row[$startcol + 18] !== null) ? (boolean) $row[$startcol + 18] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

			// FIXME - using NUM_COLUMNS may be clearer.
			return $startcol + 19; // 19 = FoundationPeer::NUM_COLUMNS - FoundationPeer::NUM_LAZY_LOAD_COLUMNS).

		} catch (Exception $e) {
			throw new PropelException("Error populating Foundation object", $e);
		}
	}

	/**
	 * Checks and repairs the internal consistency of the object.
	 *
	 * This method is executed after an already-instantiated object is re-hydrated
	 * from the database.  It exists to check any foreign keys to make sure that
	 * the objects related to the current object are correct based on foreign key.
	 *
	 * You can override this method in the stub class, but you should always invoke
	 * the base method from the overridden method (i.e. parent::ensureConsistency()),
	 * in case your model changes.
	 *
	 * @throws     PropelException
	 */
	public function ensureConsistency()
	{

		if ($this->aUser !== null && $this->user_id !== $this->aUser->getId()) {
			$this->aUser = null;
		}
		if ($this->aDistrict !== null && $this->district_id !== $this->aDistrict->getId()) {
			$this->aDistrict = null;
		}
	} // ensureConsistency

	/**
	 * Reloads this object from datastore based on primary key and (optionally) resets all associated objects.
	 *
	 * This will only work if the object has been saved and has a valid primary key set.
	 *
	 * @param      boolean $deep (optional) Whether to also de-associated any related objects.
	 * @param      PropelPDO $con (optional) The PropelPDO connection to use.
	 * @return     void
	 * @throws     PropelException - if this object is deleted, unsaved or doesn't have pk match in db
	 */
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(FoundationPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

		// We don't need to alter the object instance pool; we're just modifying this instance
		// already in the pool.

		$stmt = FoundationPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); // rehydrate

		if ($deep) {  // also de-associate any related objects?

			$this->aUser = null;
			$this->aDistrict = null;
			$this->collFoundationImages = null;
			$this->lastFoundationImageCriteria = null;

		} // if (deep)
	}

	/**
	 * Removes this object from datastore and sets delete attribute.
	 *
	 * @param      PropelPDO $con
	 * @return     void
	 * @throws     PropelException
	 * @see        BaseObject::setDeleted()
	 * @see        BaseObject::isDeleted()
	 */
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(FoundationPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$ret = $this->preDelete($con);
			// symfony_behaviors behavior
			foreach (sfMixer::getCallables('BaseFoundation:delete:pre') as $callable)
			{
			  if (call_user_func($callable, $this, $con))
			  {
			    $con->commit();
			
			    return;
			  }
			}

			if ($ret) {
				FoundationPeer::doDelete($this, $con);
				$this->postDelete($con);
				// symfony_behaviors behavior
				foreach (sfMixer::getCallables('BaseFoundation:delete:post') as $callable)
				{
				  call_user_func($callable, $this, $con);
				}

				$this->setDeleted(true);
				$con->commit();
			} else {
				$con->commit();
			}
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	/**
	 * Persists this object to the database.
	 *
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All modified related objects will also be persisted in the doSave()
	 * method.  This method wraps all precipitate database operations in a
	 * single transaction.
	 *
	 * @param      PropelPDO $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        doSave()
	 */
	public function save(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(FoundationPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		$isInsert = $this->isNew();
		try {
			$ret = $this->preSave($con);
			// symfony_behaviors behavior
			foreach (sfMixer::getCallables('BaseFoundation:save:pre') as $callable)
			{
			  if (is_integer($affectedRows = call_user_func($callable, $this, $con)))
			  {
			    $con->commit();
			
			    return $affectedRows;
			  }
			}

			if ($isInsert) {
				$ret = $ret && $this->preInsert($con);
			} else {
				$ret = $ret && $this->preUpdate($con);
			}
			if ($ret) {
				$affectedRows = $this->doSave($con);
				if ($isInsert) {
					$this->postInsert($con);
				} else {
					$this->postUpdate($con);
				}
				$this->postSave($con);
				// symfony_behaviors behavior
				foreach (sfMixer::getCallables('BaseFoundation:save:post') as $callable)
				{
				  call_user_func($callable, $this, $con, $affectedRows);
				}

				FoundationPeer::addInstanceToPool($this);
			} else {
				$affectedRows = 0;
			}
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	/**
	 * Performs the work of inserting or updating the row in the database.
	 *
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All related objects are also updated in this method.
	 *
	 * @param      PropelPDO $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        save()
	 */
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; // initialize var to track total num of affected rows
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aUser !== null) {
				if ($this->aUser->isModified() || $this->aUser->isNew()) {
					$affectedRows += $this->aUser->save($con);
				}
				$this->setUser($this->aUser);
			}

			if ($this->aDistrict !== null) {
				if ($this->aDistrict->isModified() || $this->aDistrict->isNew()) {
					$affectedRows += $this->aDistrict->save($con);
				}
				$this->setDistrict($this->aDistrict);
			}

			if ($this->isNew() ) {
				$this->modifiedColumns[] = FoundationPeer::ID;
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = FoundationPeer::doInsert($this, $con);
					$affectedRows += 1; // we are assuming that there is only 1 row per doInsert() which
										 // should always be true here (even though technically
										 // BasePeer::doInsert() can insert multiple rows).

					$this->setId($pk);  //[IMV] update autoincrement primary key

					$this->setNew(false);
				} else {
					$affectedRows += FoundationPeer::doUpdate($this, $con);
				}

				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			if ($this->collFoundationImages !== null) {
				foreach ($this->collFoundationImages as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} // doSave()

	/**
	 * Array of ValidationFailed objects.
	 * @var        array ValidationFailed[]
	 */
	protected $validationFailures = array();

	/**
	 * Gets any ValidationFailed objects that resulted from last call to validate().
	 *
	 *
	 * @return     array ValidationFailed[]
	 * @see        validate()
	 */
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	/**
	 * Validates the objects modified field values and all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param      mixed $columns Column name or an array of column names.
	 * @return     boolean Whether all columns pass validation.
	 * @see        doValidate()
	 * @see        getValidationFailures()
	 */
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	/**
	 * This function performs the validation work for complex object models.
	 *
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @param      array $columns Array of column names to validate.
	 * @return     mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aUser !== null) {
				if (!$this->aUser->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aUser->getValidationFailures());
				}
			}

			if ($this->aDistrict !== null) {
				if (!$this->aDistrict->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aDistrict->getValidationFailures());
				}
			}


			if (($retval = FoundationPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collFoundationImages !== null) {
					foreach ($this->collFoundationImages as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	/**
	 * Retrieves a field from the object by name passed in as a string.
	 *
	 * @param      string $name name
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
	 * @return     mixed Value of field.
	 */
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = FoundationPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @return     mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getUserId();
				break;
			case 2:
				return $this->getLogo();
				break;
			case 3:
				return $this->getContent();
				break;
			case 4:
				return $this->getContactPerson();
				break;
			case 5:
				return $this->getLatitude();
				break;
			case 6:
				return $this->getLongitude();
				break;
			case 7:
				return $this->getAddress();
				break;
			case 8:
				return $this->getDistrictId();
				break;
			case 9:
				return $this->getPhone();
				break;
			case 10:
				return $this->getWww();
				break;
			case 11:
				return $this->getArea0();
				break;
			case 12:
				return $this->getArea1();
				break;
			case 13:
				return $this->getArea2();
				break;
			case 14:
				return $this->getArea3();
				break;
			case 15:
				return $this->getArea4();
				break;
			case 16:
				return $this->getArea5();
				break;
			case 17:
				return $this->getArea6();
				break;
			case 18:
				return $this->getActive();
				break;
			default:
				return null;
				break;
		} // switch()
	}

	/**
	 * Exports the object as an array.
	 *
	 * You can specify the key type of the array by passing one of the class
	 * type constants.
	 *
	 * @param      string $keyType (optional) One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                        BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM. Defaults to BasePeer::TYPE_PHPNAME.
	 * @param      boolean $includeLazyLoadColumns (optional) Whether to include lazy loaded columns.  Defaults to TRUE.
	 * @return     an associative array containing the field names (as keys) and field values
	 */
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = FoundationPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getUserId(),
			$keys[2] => $this->getLogo(),
			$keys[3] => $this->getContent(),
			$keys[4] => $this->getContactPerson(),
			$keys[5] => $this->getLatitude(),
			$keys[6] => $this->getLongitude(),
			$keys[7] => $this->getAddress(),
			$keys[8] => $this->getDistrictId(),
			$keys[9] => $this->getPhone(),
			$keys[10] => $this->getWww(),
			$keys[11] => $this->getArea0(),
			$keys[12] => $this->getArea1(),
			$keys[13] => $this->getArea2(),
			$keys[14] => $this->getArea3(),
			$keys[15] => $this->getArea4(),
			$keys[16] => $this->getArea5(),
			$keys[17] => $this->getArea6(),
			$keys[18] => $this->getActive(),
		);
		return $result;
	}

	/**
	 * Sets a field from the object by name passed in as a string.
	 *
	 * @param      string $name peer name
	 * @param      mixed $value field value
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
	 * @return     void
	 */
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = FoundationPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @param      mixed $value field value
	 * @return     void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setUserId($value);
				break;
			case 2:
				$this->setLogo($value);
				break;
			case 3:
				$this->setContent($value);
				break;
			case 4:
				$this->setContactPerson($value);
				break;
			case 5:
				$this->setLatitude($value);
				break;
			case 6:
				$this->setLongitude($value);
				break;
			case 7:
				$this->setAddress($value);
				break;
			case 8:
				$this->setDistrictId($value);
				break;
			case 9:
				$this->setPhone($value);
				break;
			case 10:
				$this->setWww($value);
				break;
			case 11:
				$this->setArea0($value);
				break;
			case 12:
				$this->setArea1($value);
				break;
			case 13:
				$this->setArea2($value);
				break;
			case 14:
				$this->setArea3($value);
				break;
			case 15:
				$this->setArea4($value);
				break;
			case 16:
				$this->setArea5($value);
				break;
			case 17:
				$this->setArea6($value);
				break;
			case 18:
				$this->setActive($value);
				break;
		} // switch()
	}

	/**
	 * Populates the object using an array.
	 *
	 * This is particularly useful when populating an object from one of the
	 * request arrays (e.g. $_POST).  This method goes through the column
	 * names, checking to see whether a matching key exists in populated
	 * array. If so the setByName() method is called for that column.
	 *
	 * You can specify the key type of the array by additionally passing one
	 * of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME,
	 * BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
	 * The default key type is the column's phpname (e.g. 'AuthorId')
	 *
	 * @param      array  $arr     An array to populate the object from.
	 * @param      string $keyType The type of keys the array uses.
	 * @return     void
	 */
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = FoundationPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setUserId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setLogo($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setContent($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setContactPerson($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setLatitude($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setLongitude($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setAddress($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setDistrictId($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setPhone($arr[$keys[9]]);
		if (array_key_exists($keys[10], $arr)) $this->setWww($arr[$keys[10]]);
		if (array_key_exists($keys[11], $arr)) $this->setArea0($arr[$keys[11]]);
		if (array_key_exists($keys[12], $arr)) $this->setArea1($arr[$keys[12]]);
		if (array_key_exists($keys[13], $arr)) $this->setArea2($arr[$keys[13]]);
		if (array_key_exists($keys[14], $arr)) $this->setArea3($arr[$keys[14]]);
		if (array_key_exists($keys[15], $arr)) $this->setArea4($arr[$keys[15]]);
		if (array_key_exists($keys[16], $arr)) $this->setArea5($arr[$keys[16]]);
		if (array_key_exists($keys[17], $arr)) $this->setArea6($arr[$keys[17]]);
		if (array_key_exists($keys[18], $arr)) $this->setActive($arr[$keys[18]]);
	}

	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return     Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{
		$criteria = new Criteria(FoundationPeer::DATABASE_NAME);

		if ($this->isColumnModified(FoundationPeer::ID)) $criteria->add(FoundationPeer::ID, $this->id);
		if ($this->isColumnModified(FoundationPeer::USER_ID)) $criteria->add(FoundationPeer::USER_ID, $this->user_id);
		if ($this->isColumnModified(FoundationPeer::LOGO)) $criteria->add(FoundationPeer::LOGO, $this->logo);
		if ($this->isColumnModified(FoundationPeer::CONTENT)) $criteria->add(FoundationPeer::CONTENT, $this->content);
		if ($this->isColumnModified(FoundationPeer::CONTACT_PERSON)) $criteria->add(FoundationPeer::CONTACT_PERSON, $this->contact_person);
		if ($this->isColumnModified(FoundationPeer::LATITUDE)) $criteria->add(FoundationPeer::LATITUDE, $this->latitude);
		if ($this->isColumnModified(FoundationPeer::LONGITUDE)) $criteria->add(FoundationPeer::LONGITUDE, $this->longitude);
		if ($this->isColumnModified(FoundationPeer::ADDRESS)) $criteria->add(FoundationPeer::ADDRESS, $this->address);
		if ($this->isColumnModified(FoundationPeer::DISTRICT_ID)) $criteria->add(FoundationPeer::DISTRICT_ID, $this->district_id);
		if ($this->isColumnModified(FoundationPeer::PHONE)) $criteria->add(FoundationPeer::PHONE, $this->phone);
		if ($this->isColumnModified(FoundationPeer::WWW)) $criteria->add(FoundationPeer::WWW, $this->www);
		if ($this->isColumnModified(FoundationPeer::AREA0)) $criteria->add(FoundationPeer::AREA0, $this->area0);
		if ($this->isColumnModified(FoundationPeer::AREA1)) $criteria->add(FoundationPeer::AREA1, $this->area1);
		if ($this->isColumnModified(FoundationPeer::AREA2)) $criteria->add(FoundationPeer::AREA2, $this->area2);
		if ($this->isColumnModified(FoundationPeer::AREA3)) $criteria->add(FoundationPeer::AREA3, $this->area3);
		if ($this->isColumnModified(FoundationPeer::AREA4)) $criteria->add(FoundationPeer::AREA4, $this->area4);
		if ($this->isColumnModified(FoundationPeer::AREA5)) $criteria->add(FoundationPeer::AREA5, $this->area5);
		if ($this->isColumnModified(FoundationPeer::AREA6)) $criteria->add(FoundationPeer::AREA6, $this->area6);
		if ($this->isColumnModified(FoundationPeer::ACTIVE)) $criteria->add(FoundationPeer::ACTIVE, $this->active);

		return $criteria;
	}

	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 *
	 * @return     Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(FoundationPeer::DATABASE_NAME);

		$criteria->add(FoundationPeer::ID, $this->id);

		return $criteria;
	}

	/**
	 * Returns the primary key for this object (row).
	 * @return     int
	 */
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	/**
	 * Generic method to set the primary key (id column).
	 *
	 * @param      int $key Primary key.
	 * @return     void
	 */
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	/**
	 * Sets contents of passed object to values from current object.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      object $copyObj An object of Foundation (or compatible) type.
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @throws     PropelException
	 */
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setUserId($this->user_id);

		$copyObj->setLogo($this->logo);

		$copyObj->setContent($this->content);

		$copyObj->setContactPerson($this->contact_person);

		$copyObj->setLatitude($this->latitude);

		$copyObj->setLongitude($this->longitude);

		$copyObj->setAddress($this->address);

		$copyObj->setDistrictId($this->district_id);

		$copyObj->setPhone($this->phone);

		$copyObj->setWww($this->www);

		$copyObj->setArea0($this->area0);

		$copyObj->setArea1($this->area1);

		$copyObj->setArea2($this->area2);

		$copyObj->setArea3($this->area3);

		$copyObj->setArea4($this->area4);

		$copyObj->setArea5($this->area5);

		$copyObj->setArea6($this->area6);

		$copyObj->setActive($this->active);


		if ($deepCopy) {
			// important: temporarily setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach ($this->getFoundationImages() as $relObj) {
				if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
					$copyObj->addFoundationImage($relObj->copy($deepCopy));
				}
			}

		} // if ($deepCopy)


		$copyObj->setNew(true);

		$copyObj->setId(NULL); // this is a auto-increment column, so set to default value

	}

	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @return     Foundation Clone of current object.
	 * @throws     PropelException
	 */
	public function copy($deepCopy = false)
	{
		// we use get_class(), because this might be a subclass
		$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	/**
	 * Returns a peer instance associated with this om.
	 *
	 * Since Peer classes are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 *
	 * @return     FoundationPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new FoundationPeer();
		}
		return self::$peer;
	}

	/**
	 * Declares an association between this object and a User object.
	 *
	 * @param      User $v
	 * @return     Foundation The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setUser(User $v = null)
	{
		if ($v === null) {
			$this->setUserId(NULL);
		} else {
			$this->setUserId($v->getId());
		}

		$this->aUser = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the User object, it will not be re-added.
		if ($v !== null) {
			$v->addFoundation($this);
		}

		return $this;
	}


	/**
	 * Get the associated User object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     User The associated User object.
	 * @throws     PropelException
	 */
	public function getUser(PropelPDO $con = null)
	{
		if ($this->aUser === null && ($this->user_id !== null)) {
			$this->aUser = UserPeer::retrieveByPk($this->user_id);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aUser->addFoundations($this);
			 */
		}
		return $this->aUser;
	}

	/**
	 * Declares an association between this object and a District object.
	 *
	 * @param      District $v
	 * @return     Foundation The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setDistrict(District $v = null)
	{
		if ($v === null) {
			$this->setDistrictId(1);
		} else {
			$this->setDistrictId($v->getId());
		}

		$this->aDistrict = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the District object, it will not be re-added.
		if ($v !== null) {
			$v->addFoundation($this);
		}

		return $this;
	}


	/**
	 * Get the associated District object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     District The associated District object.
	 * @throws     PropelException
	 */
	public function getDistrict(PropelPDO $con = null)
	{
		if ($this->aDistrict === null && ($this->district_id !== null)) {
			$this->aDistrict = DistrictPeer::retrieveByPk($this->district_id);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aDistrict->addFoundations($this);
			 */
		}
		return $this->aDistrict;
	}

	/**
	 * Clears out the collFoundationImages collection (array).
	 *
	 * This does not modify the database; however, it will remove any associated objects, causing
	 * them to be refetched by subsequent calls to accessor method.
	 *
	 * @return     void
	 * @see        addFoundationImages()
	 */
	public function clearFoundationImages()
	{
		$this->collFoundationImages = null; // important to set this to NULL since that means it is uninitialized
	}

	/**
	 * Initializes the collFoundationImages collection (array).
	 *
	 * By default this just sets the collFoundationImages collection to an empty array (like clearcollFoundationImages());
	 * however, you may wish to override this method in your stub class to provide setting appropriate
	 * to your application -- for example, setting the initial array to the values stored in database.
	 *
	 * @return     void
	 */
	public function initFoundationImages()
	{
		$this->collFoundationImages = array();
	}

	/**
	 * Gets an array of FoundationImage objects which contain a foreign key that references this object.
	 *
	 * If this collection has already been initialized with an identical Criteria, it returns the collection.
	 * Otherwise if this Foundation has previously been saved, it will retrieve
	 * related FoundationImages from storage. If this Foundation is new, it will return
	 * an empty collection or the current collection, the criteria is ignored on a new object.
	 *
	 * @param      PropelPDO $con
	 * @param      Criteria $criteria
	 * @return     array FoundationImage[]
	 * @throws     PropelException
	 */
	public function getFoundationImages($criteria = null, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(FoundationPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collFoundationImages === null) {
			if ($this->isNew()) {
			   $this->collFoundationImages = array();
			} else {

				$criteria->add(FoundationImagePeer::FOUNDATION_ID, $this->id);

				FoundationImagePeer::addSelectColumns($criteria);
				$this->collFoundationImages = FoundationImagePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(FoundationImagePeer::FOUNDATION_ID, $this->id);

				FoundationImagePeer::addSelectColumns($criteria);
				if (!isset($this->lastFoundationImageCriteria) || !$this->lastFoundationImageCriteria->equals($criteria)) {
					$this->collFoundationImages = FoundationImagePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastFoundationImageCriteria = $criteria;
		return $this->collFoundationImages;
	}

	/**
	 * Returns the number of related FoundationImage objects.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      PropelPDO $con
	 * @return     int Count of related FoundationImage objects.
	 * @throws     PropelException
	 */
	public function countFoundationImages(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
	{
		if ($criteria === null) {
			$criteria = new Criteria(FoundationPeer::DATABASE_NAME);
		} else {
			$criteria = clone $criteria;
		}

		if ($distinct) {
			$criteria->setDistinct();
		}

		$count = null;

		if ($this->collFoundationImages === null) {
			if ($this->isNew()) {
				$count = 0;
			} else {

				$criteria->add(FoundationImagePeer::FOUNDATION_ID, $this->id);

				$count = FoundationImagePeer::doCount($criteria, false, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return count of the collection.


				$criteria->add(FoundationImagePeer::FOUNDATION_ID, $this->id);

				if (!isset($this->lastFoundationImageCriteria) || !$this->lastFoundationImageCriteria->equals($criteria)) {
					$count = FoundationImagePeer::doCount($criteria, false, $con);
				} else {
					$count = count($this->collFoundationImages);
				}
			} else {
				$count = count($this->collFoundationImages);
			}
		}
		return $count;
	}

	/**
	 * Method called to associate a FoundationImage object to this object
	 * through the FoundationImage foreign key attribute.
	 *
	 * @param      FoundationImage $l FoundationImage
	 * @return     void
	 * @throws     PropelException
	 */
	public function addFoundationImage(FoundationImage $l)
	{
		if ($this->collFoundationImages === null) {
			$this->initFoundationImages();
		}
		if (!in_array($l, $this->collFoundationImages, true)) { // only add it if the **same** object is not already associated
			array_push($this->collFoundationImages, $l);
			$l->setFoundation($this);
		}
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Foundation is new, it will return
	 * an empty collection; or if this Foundation has previously
	 * been saved, it will retrieve related FoundationImages from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Foundation.
	 */
	public function getFoundationImagesJoinProjects($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(FoundationPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collFoundationImages === null) {
			if ($this->isNew()) {
				$this->collFoundationImages = array();
			} else {

				$criteria->add(FoundationImagePeer::FOUNDATION_ID, $this->id);

				$this->collFoundationImages = FoundationImagePeer::doSelectJoinProjects($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(FoundationImagePeer::FOUNDATION_ID, $this->id);

			if (!isset($this->lastFoundationImageCriteria) || !$this->lastFoundationImageCriteria->equals($criteria)) {
				$this->collFoundationImages = FoundationImagePeer::doSelectJoinProjects($criteria, $con, $join_behavior);
			}
		}
		$this->lastFoundationImageCriteria = $criteria;

		return $this->collFoundationImages;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Foundation is new, it will return
	 * an empty collection; or if this Foundation has previously
	 * been saved, it will retrieve related FoundationImages from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Foundation.
	 */
	public function getFoundationImagesJoinGallery($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
	{
		if ($criteria === null) {
			$criteria = new Criteria(FoundationPeer::DATABASE_NAME);
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collFoundationImages === null) {
			if ($this->isNew()) {
				$this->collFoundationImages = array();
			} else {

				$criteria->add(FoundationImagePeer::FOUNDATION_ID, $this->id);

				$this->collFoundationImages = FoundationImagePeer::doSelectJoinGallery($criteria, $con, $join_behavior);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(FoundationImagePeer::FOUNDATION_ID, $this->id);

			if (!isset($this->lastFoundationImageCriteria) || !$this->lastFoundationImageCriteria->equals($criteria)) {
				$this->collFoundationImages = FoundationImagePeer::doSelectJoinGallery($criteria, $con, $join_behavior);
			}
		}
		$this->lastFoundationImageCriteria = $criteria;

		return $this->collFoundationImages;
	}

	/**
	 * Resets all collections of referencing foreign keys.
	 *
	 * This method is a user-space workaround for PHP's inability to garbage collect objects
	 * with circular references.  This is currently necessary when using Propel in certain
	 * daemon or large-volumne/high-memory operations.
	 *
	 * @param      boolean $deep Whether to also clear the references on all associated objects.
	 */
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
			if ($this->collFoundationImages) {
				foreach ((array) $this->collFoundationImages as $o) {
					$o->clearAllReferences($deep);
				}
			}
		} // if ($deep)

		$this->collFoundationImages = null;
			$this->aUser = null;
			$this->aDistrict = null;
	}

	// symfony_behaviors behavior
	
	/**
	 * Calls methods defined via {@link sfMixer}.
	 */
	public function __call($method, $arguments)
	{
	  if (!$callable = sfMixer::getCallable('BaseFoundation:'.$method))
	  {
	    throw new sfException(sprintf('Call to undefined method BaseFoundation::%s', $method));
	  }
	
	  array_unshift($arguments, $this);
	
	  return call_user_func_array($callable, $arguments);
	}

} // BaseFoundation
