<?php

/**
 * Base class that represents a row from the 'foundation_image' table.
 *
 * 
 *
 * This class was autogenerated by Propel 1.4.2 on:
 *
 * 11/11/16 11:30:20
 *
 * @package    lib.model.om
 */
abstract class BaseFoundationImage extends BaseObject  implements Persistent {


	/**
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var        FoundationImagePeer
	 */
	protected static $peer;

	/**
	 * The value for the id field.
	 * @var        int
	 */
	protected $id;

	/**
	 * The value for the foundation_id field.
	 * @var        int
	 */
	protected $foundation_id;

	/**
	 * The value for the project_id field.
	 * @var        int
	 */
	protected $project_id;

	/**
	 * The value for the gallery_id field.
	 * @var        int
	 */
	protected $gallery_id;

	/**
	 * The value for the image field.
	 * @var        string
	 */
	protected $image;

	/**
	 * The value for the logo_link field.
	 * @var        string
	 */
	protected $logo_link;

	/**
	 * The value for the is_logo field.
	 * @var        boolean
	 */
	protected $is_logo;

	/**
	 * @var        Foundation
	 */
	protected $aFoundation;

	/**
	 * @var        Projects
	 */
	protected $aProjects;

	/**
	 * @var        Gallery
	 */
	protected $aGallery;

	/**
	 * Flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInSave = false;

	/**
	 * Flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInValidation = false;

	// symfony behavior
	
	const PEER = 'FoundationImagePeer';

	/**
	 * Get the [id] column value.
	 * 
	 * @return     int
	 */
	public function getId()
	{
		return $this->id;
	}

	/**
	 * Get the [foundation_id] column value.
	 * 
	 * @return     int
	 */
	public function getFoundationId()
	{
		return $this->foundation_id;
	}

	/**
	 * Get the [project_id] column value.
	 * 
	 * @return     int
	 */
	public function getProjectId()
	{
		return $this->project_id;
	}

	/**
	 * Get the [gallery_id] column value.
	 * 
	 * @return     int
	 */
	public function getGalleryId()
	{
		return $this->gallery_id;
	}

	/**
	 * Get the [image] column value.
	 * 
	 * @return     string
	 */
	public function getImage()
	{
		return $this->image;
	}

	/**
	 * Get the [logo_link] column value.
	 * 
	 * @return     string
	 */
	public function getLogoLink()
	{
		return $this->logo_link;
	}

	/**
	 * Get the [is_logo] column value.
	 * 
	 * @return     boolean
	 */
	public function getIsLogo()
	{
		return $this->is_logo;
	}

	/**
	 * Set the value of [id] column.
	 * 
	 * @param      int $v new value
	 * @return     FoundationImage The current object (for fluent API support)
	 */
	public function setId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = FoundationImagePeer::ID;
		}

		return $this;
	} // setId()

	/**
	 * Set the value of [foundation_id] column.
	 * 
	 * @param      int $v new value
	 * @return     FoundationImage The current object (for fluent API support)
	 */
	public function setFoundationId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->foundation_id !== $v) {
			$this->foundation_id = $v;
			$this->modifiedColumns[] = FoundationImagePeer::FOUNDATION_ID;
		}

		if ($this->aFoundation !== null && $this->aFoundation->getId() !== $v) {
			$this->aFoundation = null;
		}

		return $this;
	} // setFoundationId()

	/**
	 * Set the value of [project_id] column.
	 * 
	 * @param      int $v new value
	 * @return     FoundationImage The current object (for fluent API support)
	 */
	public function setProjectId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->project_id !== $v) {
			$this->project_id = $v;
			$this->modifiedColumns[] = FoundationImagePeer::PROJECT_ID;
		}

		if ($this->aProjects !== null && $this->aProjects->getId() !== $v) {
			$this->aProjects = null;
		}

		return $this;
	} // setProjectId()

	/**
	 * Set the value of [gallery_id] column.
	 * 
	 * @param      int $v new value
	 * @return     FoundationImage The current object (for fluent API support)
	 */
	public function setGalleryId($v)
	{
		if ($v !== null) {
			$v = (int) $v;
		}

		if ($this->gallery_id !== $v) {
			$this->gallery_id = $v;
			$this->modifiedColumns[] = FoundationImagePeer::GALLERY_ID;
		}

		if ($this->aGallery !== null && $this->aGallery->getId() !== $v) {
			$this->aGallery = null;
		}

		return $this;
	} // setGalleryId()

	/**
	 * Set the value of [image] column.
	 * 
	 * @param      string $v new value
	 * @return     FoundationImage The current object (for fluent API support)
	 */
	public function setImage($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->image !== $v) {
			$this->image = $v;
			$this->modifiedColumns[] = FoundationImagePeer::IMAGE;
		}

		return $this;
	} // setImage()

	/**
	 * Set the value of [logo_link] column.
	 * 
	 * @param      string $v new value
	 * @return     FoundationImage The current object (for fluent API support)
	 */
	public function setLogoLink($v)
	{
		if ($v !== null) {
			$v = (string) $v;
		}

		if ($this->logo_link !== $v) {
			$this->logo_link = $v;
			$this->modifiedColumns[] = FoundationImagePeer::LOGO_LINK;
		}

		return $this;
	} // setLogoLink()

	/**
	 * Set the value of [is_logo] column.
	 * 
	 * @param      boolean $v new value
	 * @return     FoundationImage The current object (for fluent API support)
	 */
	public function setIsLogo($v)
	{
		if ($v !== null) {
			$v = (boolean) $v;
		}

		if ($this->is_logo !== $v) {
			$this->is_logo = $v;
			$this->modifiedColumns[] = FoundationImagePeer::IS_LOGO;
		}

		return $this;
	} // setIsLogo()

	/**
	 * Indicates whether the columns in this object are only set to default values.
	 *
	 * This method can be used in conjunction with isModified() to indicate whether an object is both
	 * modified _and_ has some values set which are non-default.
	 *
	 * @return     boolean Whether the columns in this object are only been set with default values.
	 */
	public function hasOnlyDefaultValues()
	{
		// otherwise, everything was equal, so return TRUE
		return true;
	} // hasOnlyDefaultValues()

	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (0-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param      array $row The row returned by PDOStatement->fetch(PDO::FETCH_NUM)
	 * @param      int $startcol 0-based offset column which indicates which restultset column to start with.
	 * @param      boolean $rehydrate Whether this object is being re-hydrated from the database.
	 * @return     int next starting column
	 * @throws     PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate($row, $startcol = 0, $rehydrate = false)
	{
		try {

			$this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
			$this->foundation_id = ($row[$startcol + 1] !== null) ? (int) $row[$startcol + 1] : null;
			$this->project_id = ($row[$startcol + 2] !== null) ? (int) $row[$startcol + 2] : null;
			$this->gallery_id = ($row[$startcol + 3] !== null) ? (int) $row[$startcol + 3] : null;
			$this->image = ($row[$startcol + 4] !== null) ? (string) $row[$startcol + 4] : null;
			$this->logo_link = ($row[$startcol + 5] !== null) ? (string) $row[$startcol + 5] : null;
			$this->is_logo = ($row[$startcol + 6] !== null) ? (boolean) $row[$startcol + 6] : null;
			$this->resetModified();

			$this->setNew(false);

			if ($rehydrate) {
				$this->ensureConsistency();
			}

			// FIXME - using NUM_COLUMNS may be clearer.
			return $startcol + 7; // 7 = FoundationImagePeer::NUM_COLUMNS - FoundationImagePeer::NUM_LAZY_LOAD_COLUMNS).

		} catch (Exception $e) {
			throw new PropelException("Error populating FoundationImage object", $e);
		}
	}

	/**
	 * Checks and repairs the internal consistency of the object.
	 *
	 * This method is executed after an already-instantiated object is re-hydrated
	 * from the database.  It exists to check any foreign keys to make sure that
	 * the objects related to the current object are correct based on foreign key.
	 *
	 * You can override this method in the stub class, but you should always invoke
	 * the base method from the overridden method (i.e. parent::ensureConsistency()),
	 * in case your model changes.
	 *
	 * @throws     PropelException
	 */
	public function ensureConsistency()
	{

		if ($this->aFoundation !== null && $this->foundation_id !== $this->aFoundation->getId()) {
			$this->aFoundation = null;
		}
		if ($this->aProjects !== null && $this->project_id !== $this->aProjects->getId()) {
			$this->aProjects = null;
		}
		if ($this->aGallery !== null && $this->gallery_id !== $this->aGallery->getId()) {
			$this->aGallery = null;
		}
	} // ensureConsistency

	/**
	 * Reloads this object from datastore based on primary key and (optionally) resets all associated objects.
	 *
	 * This will only work if the object has been saved and has a valid primary key set.
	 *
	 * @param      boolean $deep (optional) Whether to also de-associated any related objects.
	 * @param      PropelPDO $con (optional) The PropelPDO connection to use.
	 * @return     void
	 * @throws     PropelException - if this object is deleted, unsaved or doesn't have pk match in db
	 */
	public function reload($deep = false, PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("Cannot reload a deleted object.");
		}

		if ($this->isNew()) {
			throw new PropelException("Cannot reload an unsaved object.");
		}

		if ($con === null) {
			$con = Propel::getConnection(FoundationImagePeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

		// We don't need to alter the object instance pool; we're just modifying this instance
		// already in the pool.

		$stmt = FoundationImagePeer::doSelectStmt($this->buildPkeyCriteria(), $con);
		$row = $stmt->fetch(PDO::FETCH_NUM);
		$stmt->closeCursor();
		if (!$row) {
			throw new PropelException('Cannot find matching row in the database to reload object values.');
		}
		$this->hydrate($row, 0, true); // rehydrate

		if ($deep) {  // also de-associate any related objects?

			$this->aFoundation = null;
			$this->aProjects = null;
			$this->aGallery = null;
		} // if (deep)
	}

	/**
	 * Removes this object from datastore and sets delete attribute.
	 *
	 * @param      PropelPDO $con
	 * @return     void
	 * @throws     PropelException
	 * @see        BaseObject::setDeleted()
	 * @see        BaseObject::isDeleted()
	 */
	public function delete(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(FoundationImagePeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		try {
			$ret = $this->preDelete($con);
			// symfony_behaviors behavior
			foreach (sfMixer::getCallables('BaseFoundationImage:delete:pre') as $callable)
			{
			  if (call_user_func($callable, $this, $con))
			  {
			    $con->commit();
			
			    return;
			  }
			}

			if ($ret) {
				FoundationImagePeer::doDelete($this, $con);
				$this->postDelete($con);
				// symfony_behaviors behavior
				foreach (sfMixer::getCallables('BaseFoundationImage:delete:post') as $callable)
				{
				  call_user_func($callable, $this, $con);
				}

				$this->setDeleted(true);
				$con->commit();
			} else {
				$con->commit();
			}
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	/**
	 * Persists this object to the database.
	 *
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All modified related objects will also be persisted in the doSave()
	 * method.  This method wraps all precipitate database operations in a
	 * single transaction.
	 *
	 * @param      PropelPDO $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        doSave()
	 */
	public function save(PropelPDO $con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(FoundationImagePeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		
		$con->beginTransaction();
		$isInsert = $this->isNew();
		try {
			$ret = $this->preSave($con);
			// symfony_behaviors behavior
			foreach (sfMixer::getCallables('BaseFoundationImage:save:pre') as $callable)
			{
			  if (is_integer($affectedRows = call_user_func($callable, $this, $con)))
			  {
			    $con->commit();
			
			    return $affectedRows;
			  }
			}

			if ($isInsert) {
				$ret = $ret && $this->preInsert($con);
			} else {
				$ret = $ret && $this->preUpdate($con);
			}
			if ($ret) {
				$affectedRows = $this->doSave($con);
				if ($isInsert) {
					$this->postInsert($con);
				} else {
					$this->postUpdate($con);
				}
				$this->postSave($con);
				// symfony_behaviors behavior
				foreach (sfMixer::getCallables('BaseFoundationImage:save:post') as $callable)
				{
				  call_user_func($callable, $this, $con, $affectedRows);
				}

				FoundationImagePeer::addInstanceToPool($this);
			} else {
				$affectedRows = 0;
			}
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	/**
	 * Performs the work of inserting or updating the row in the database.
	 *
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All related objects are also updated in this method.
	 *
	 * @param      PropelPDO $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        save()
	 */
	protected function doSave(PropelPDO $con)
	{
		$affectedRows = 0; // initialize var to track total num of affected rows
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aFoundation !== null) {
				if ($this->aFoundation->isModified() || $this->aFoundation->isNew()) {
					$affectedRows += $this->aFoundation->save($con);
				}
				$this->setFoundation($this->aFoundation);
			}

			if ($this->aProjects !== null) {
				if ($this->aProjects->isModified() || $this->aProjects->isNew()) {
					$affectedRows += $this->aProjects->save($con);
				}
				$this->setProjects($this->aProjects);
			}

			if ($this->aGallery !== null) {
				if ($this->aGallery->isModified() || $this->aGallery->isNew()) {
					$affectedRows += $this->aGallery->save($con);
				}
				$this->setGallery($this->aGallery);
			}

			if ($this->isNew() ) {
				$this->modifiedColumns[] = FoundationImagePeer::ID;
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = FoundationImagePeer::doInsert($this, $con);
					$affectedRows += 1; // we are assuming that there is only 1 row per doInsert() which
										 // should always be true here (even though technically
										 // BasePeer::doInsert() can insert multiple rows).

					$this->setId($pk);  //[IMV] update autoincrement primary key

					$this->setNew(false);
				} else {
					$affectedRows += FoundationImagePeer::doUpdate($this, $con);
				}

				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;

		}
		return $affectedRows;
	} // doSave()

	/**
	 * Array of ValidationFailed objects.
	 * @var        array ValidationFailed[]
	 */
	protected $validationFailures = array();

	/**
	 * Gets any ValidationFailed objects that resulted from last call to validate().
	 *
	 *
	 * @return     array ValidationFailed[]
	 * @see        validate()
	 */
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	/**
	 * Validates the objects modified field values and all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param      mixed $columns Column name or an array of column names.
	 * @return     boolean Whether all columns pass validation.
	 * @see        doValidate()
	 * @see        getValidationFailures()
	 */
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	/**
	 * This function performs the validation work for complex object models.
	 *
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @param      array $columns Array of column names to validate.
	 * @return     mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aFoundation !== null) {
				if (!$this->aFoundation->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aFoundation->getValidationFailures());
				}
			}

			if ($this->aProjects !== null) {
				if (!$this->aProjects->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aProjects->getValidationFailures());
				}
			}

			if ($this->aGallery !== null) {
				if (!$this->aGallery->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aGallery->getValidationFailures());
				}
			}


			if (($retval = FoundationImagePeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	/**
	 * Retrieves a field from the object by name passed in as a string.
	 *
	 * @param      string $name name
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
	 * @return     mixed Value of field.
	 */
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = FoundationImagePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		$field = $this->getByPosition($pos);
		return $field;
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @return     mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getFoundationId();
				break;
			case 2:
				return $this->getProjectId();
				break;
			case 3:
				return $this->getGalleryId();
				break;
			case 4:
				return $this->getImage();
				break;
			case 5:
				return $this->getLogoLink();
				break;
			case 6:
				return $this->getIsLogo();
				break;
			default:
				return null;
				break;
		} // switch()
	}

	/**
	 * Exports the object as an array.
	 *
	 * You can specify the key type of the array by passing one of the class
	 * type constants.
	 *
	 * @param      string $keyType (optional) One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                        BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM. Defaults to BasePeer::TYPE_PHPNAME.
	 * @param      boolean $includeLazyLoadColumns (optional) Whether to include lazy loaded columns.  Defaults to TRUE.
	 * @return     an associative array containing the field names (as keys) and field values
	 */
	public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true)
	{
		$keys = FoundationImagePeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getFoundationId(),
			$keys[2] => $this->getProjectId(),
			$keys[3] => $this->getGalleryId(),
			$keys[4] => $this->getImage(),
			$keys[5] => $this->getLogoLink(),
			$keys[6] => $this->getIsLogo(),
		);
		return $result;
	}

	/**
	 * Sets a field from the object by name passed in as a string.
	 *
	 * @param      string $name peer name
	 * @param      mixed $value field value
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
	 *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
	 * @return     void
	 */
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = FoundationImagePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @param      mixed $value field value
	 * @return     void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setFoundationId($value);
				break;
			case 2:
				$this->setProjectId($value);
				break;
			case 3:
				$this->setGalleryId($value);
				break;
			case 4:
				$this->setImage($value);
				break;
			case 5:
				$this->setLogoLink($value);
				break;
			case 6:
				$this->setIsLogo($value);
				break;
		} // switch()
	}

	/**
	 * Populates the object using an array.
	 *
	 * This is particularly useful when populating an object from one of the
	 * request arrays (e.g. $_POST).  This method goes through the column
	 * names, checking to see whether a matching key exists in populated
	 * array. If so the setByName() method is called for that column.
	 *
	 * You can specify the key type of the array by additionally passing one
	 * of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME,
	 * BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
	 * The default key type is the column's phpname (e.g. 'AuthorId')
	 *
	 * @param      array  $arr     An array to populate the object from.
	 * @param      string $keyType The type of keys the array uses.
	 * @return     void
	 */
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = FoundationImagePeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setFoundationId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setProjectId($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setGalleryId($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setImage($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setLogoLink($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setIsLogo($arr[$keys[6]]);
	}

	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return     Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{
		$criteria = new Criteria(FoundationImagePeer::DATABASE_NAME);

		if ($this->isColumnModified(FoundationImagePeer::ID)) $criteria->add(FoundationImagePeer::ID, $this->id);
		if ($this->isColumnModified(FoundationImagePeer::FOUNDATION_ID)) $criteria->add(FoundationImagePeer::FOUNDATION_ID, $this->foundation_id);
		if ($this->isColumnModified(FoundationImagePeer::PROJECT_ID)) $criteria->add(FoundationImagePeer::PROJECT_ID, $this->project_id);
		if ($this->isColumnModified(FoundationImagePeer::GALLERY_ID)) $criteria->add(FoundationImagePeer::GALLERY_ID, $this->gallery_id);
		if ($this->isColumnModified(FoundationImagePeer::IMAGE)) $criteria->add(FoundationImagePeer::IMAGE, $this->image);
		if ($this->isColumnModified(FoundationImagePeer::LOGO_LINK)) $criteria->add(FoundationImagePeer::LOGO_LINK, $this->logo_link);
		if ($this->isColumnModified(FoundationImagePeer::IS_LOGO)) $criteria->add(FoundationImagePeer::IS_LOGO, $this->is_logo);

		return $criteria;
	}

	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 *
	 * @return     Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(FoundationImagePeer::DATABASE_NAME);

		$criteria->add(FoundationImagePeer::ID, $this->id);

		return $criteria;
	}

	/**
	 * Returns the primary key for this object (row).
	 * @return     int
	 */
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	/**
	 * Generic method to set the primary key (id column).
	 *
	 * @param      int $key Primary key.
	 * @return     void
	 */
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	/**
	 * Sets contents of passed object to values from current object.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      object $copyObj An object of FoundationImage (or compatible) type.
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @throws     PropelException
	 */
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setFoundationId($this->foundation_id);

		$copyObj->setProjectId($this->project_id);

		$copyObj->setGalleryId($this->gallery_id);

		$copyObj->setImage($this->image);

		$copyObj->setLogoLink($this->logo_link);

		$copyObj->setIsLogo($this->is_logo);


		$copyObj->setNew(true);

		$copyObj->setId(NULL); // this is a auto-increment column, so set to default value

	}

	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @return     FoundationImage Clone of current object.
	 * @throws     PropelException
	 */
	public function copy($deepCopy = false)
	{
		// we use get_class(), because this might be a subclass
		$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	/**
	 * Returns a peer instance associated with this om.
	 *
	 * Since Peer classes are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 *
	 * @return     FoundationImagePeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new FoundationImagePeer();
		}
		return self::$peer;
	}

	/**
	 * Declares an association between this object and a Foundation object.
	 *
	 * @param      Foundation $v
	 * @return     FoundationImage The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setFoundation(Foundation $v = null)
	{
		if ($v === null) {
			$this->setFoundationId(NULL);
		} else {
			$this->setFoundationId($v->getId());
		}

		$this->aFoundation = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the Foundation object, it will not be re-added.
		if ($v !== null) {
			$v->addFoundationImage($this);
		}

		return $this;
	}


	/**
	 * Get the associated Foundation object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     Foundation The associated Foundation object.
	 * @throws     PropelException
	 */
	public function getFoundation(PropelPDO $con = null)
	{
		if ($this->aFoundation === null && ($this->foundation_id !== null)) {
			$this->aFoundation = FoundationPeer::retrieveByPk($this->foundation_id);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aFoundation->addFoundationImages($this);
			 */
		}
		return $this->aFoundation;
	}

	/**
	 * Declares an association between this object and a Projects object.
	 *
	 * @param      Projects $v
	 * @return     FoundationImage The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setProjects(Projects $v = null)
	{
		if ($v === null) {
			$this->setProjectId(NULL);
		} else {
			$this->setProjectId($v->getId());
		}

		$this->aProjects = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the Projects object, it will not be re-added.
		if ($v !== null) {
			$v->addFoundationImage($this);
		}

		return $this;
	}


	/**
	 * Get the associated Projects object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     Projects The associated Projects object.
	 * @throws     PropelException
	 */
	public function getProjects(PropelPDO $con = null)
	{
		if ($this->aProjects === null && ($this->project_id !== null)) {
			$this->aProjects = ProjectsPeer::retrieveByPk($this->project_id);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aProjects->addFoundationImages($this);
			 */
		}
		return $this->aProjects;
	}

	/**
	 * Declares an association between this object and a Gallery object.
	 *
	 * @param      Gallery $v
	 * @return     FoundationImage The current object (for fluent API support)
	 * @throws     PropelException
	 */
	public function setGallery(Gallery $v = null)
	{
		if ($v === null) {
			$this->setGalleryId(NULL);
		} else {
			$this->setGalleryId($v->getId());
		}

		$this->aGallery = $v;

		// Add binding for other direction of this n:n relationship.
		// If this object has already been added to the Gallery object, it will not be re-added.
		if ($v !== null) {
			$v->addFoundationImage($this);
		}

		return $this;
	}


	/**
	 * Get the associated Gallery object
	 *
	 * @param      PropelPDO Optional Connection object.
	 * @return     Gallery The associated Gallery object.
	 * @throws     PropelException
	 */
	public function getGallery(PropelPDO $con = null)
	{
		if ($this->aGallery === null && ($this->gallery_id !== null)) {
			$this->aGallery = GalleryPeer::retrieveByPk($this->gallery_id);
			/* The following can be used additionally to
			   guarantee the related object contains a reference
			   to this object.  This level of coupling may, however, be
			   undesirable since it could result in an only partially populated collection
			   in the referenced object.
			   $this->aGallery->addFoundationImages($this);
			 */
		}
		return $this->aGallery;
	}

	/**
	 * Resets all collections of referencing foreign keys.
	 *
	 * This method is a user-space workaround for PHP's inability to garbage collect objects
	 * with circular references.  This is currently necessary when using Propel in certain
	 * daemon or large-volumne/high-memory operations.
	 *
	 * @param      boolean $deep Whether to also clear the references on all associated objects.
	 */
	public function clearAllReferences($deep = false)
	{
		if ($deep) {
		} // if ($deep)

			$this->aFoundation = null;
			$this->aProjects = null;
			$this->aGallery = null;
	}

	// symfony_behaviors behavior
	
	/**
	 * Calls methods defined via {@link sfMixer}.
	 */
	public function __call($method, $arguments)
	{
	  if (!$callable = sfMixer::getCallable('BaseFoundationImage:'.$method))
	  {
	    throw new sfException(sprintf('Call to undefined method BaseFoundationImage::%s', $method));
	  }
	
	  array_unshift($arguments, $this);
	
	  return call_user_func_array($callable, $arguments);
	}

} // BaseFoundationImage
