<?php

/**
 * Foundation form.
 *
 * @package    Kiwi
 * @subpackage form
 * @author     Your name here
 */
class FoundationForm extends BaseFoundationForm
{
	


function setPath( $path) {
		
			$this->widgetSchema['logo']->setOption('file_src', sfConfig::get('app_sever_name').sfConfig::get('app_foundation_logo_path').$path);
   }
	
  public function configure()
  {
  	
  	
  	$this->widgetSchema['logo'] = new sfWidgetFormInputFileEditable(array(
      'label'     => 'Logo',
      'file_src'  => sfConfig::get('app_sever_name').sfConfig::get('app_foundation_logo_path'),
      'is_image'  => true,
      'template'  => '<div>%file%<br />%input%</div>',
    ));
    $this->widgetSchema['content']->setAttributes(array('cols' => 80, 'rows' => 20));
    $this->widgetSchema['content']->setOption("label", "Opis");
    $this->widgetSchema['contact_person']->setOption("label", "Osoba kontaktowa");
    $this->widgetSchema['phone']->setOption("label", "Telefon");
    $this->widgetSchema['name'] = new sfWidgetFormInputText(array('label'     => 'Nazwa'), array('size' => 80, 'MAXLENGTH' => 250));
    $this->widgetSchema['address'] = new sfWidgetFormGMapAddress(array('label'     => 'Adres'));
    $this->widgetSchema['latitude'] = new sfWidgetFormInputHidden(array(),  array("id" => "latitude"));
    $this->widgetSchema['longitude'] = new sfWidgetFormInputHidden(array(), array("id" => "longitude"));
    
    $this->widgetSchema['newImage'] = new sfWidgetFormInputFileEditable(array(
      'label'     => 'Nowe zdjęcie',
      'file_src'  => sfConfig::get('app_sever_name').sfConfig::get('app_foundation_gallery_path'),
      'is_image'  => true,
      'template'  => '<div>%input%%delete%</div>',
    ));
    
	 $cities = CityPeer::doSelect(new Criteria());
	
     $this->widgetSchema['city_id'] = new sfWidgetFormChoice(array(
		  'choices'  => formHelper::o2a($cities),
		  'multiple' => false,
		  'expanded' => false,
     	  'label'    => 'Miasto'
		), array('id' => 'adminCity'));
    
     $districts = array_merge(array(0=> ""), formHelper::o2a($cities[0]->getDistricts()));
     
	 $this->widgetSchema['district_id'] = new sfWidgetFormChoice(array(
		  'choices'  => $districts,
		  'multiple' => false,
		  'expanded' => false,
     	  'label'    => 'Dzielnica'
		), array('id' => 'adminDistrict'));	
	 
	 $this->widgetSchema["rules"] = new sfWidgetFormInputCheckbox(array("label" => "Akceptuję regulamin serwisu"));
	 
	 
	$this->setValidators(array(
     'name' => new sfValidatorString(
    			array('max_length' => 250, 
    				  'min_length' => 3
    				  ), 
    			array('max_length' => 'Za długa nazwa- wprowadź nazwę zawierającą od 3 do 250 znaków', 
    				  'min_length' => 'Za krótka nazwa - wprowadź nazwę zawierającą od 3 do 250 znaków'
    					)
    			),
    'phone' => new sfValidatorRegex(
    			array('pattern' => "#\b[+]?[\\d-\\s]{9,20}\b#" ), 
    			array('invalid' => 'Wprowadź prawidłowy numer telefonu (np +48-58-1234567)',
    				'required' => 'Wprowadź prawidłowy numer telefonu (np +48-58-1234567)')
    			),
    'logo' => new sfValidatorFile(
    			array('required'   => false,
					  'path'       => sfConfig::get('app_foundation_logo_path'),
					  'mime_types' => 'web_images',
				  	  'max_size'   => sfConfig::get('app_max_picture_size')
					), 
				array("mime_types" => "Nieprawidłowy format zdjęcia - %mime_type%", 
					  "max_size" => "Zdjęcie za duże - maksymalna wielkość to %max_size% bajtów"
					)
				),
    'newImage' => new sfValidatorFile(
    			array('required'   => false,
					  'path'       => sfConfig::get('app_foundation_gallery_path'),
					  'mime_types' => 'web_images',
				  	  'max_size'   => sfConfig::get('app_max_picture_size')
					), 
				array("mime_types" => "Nieprawidłowy format zdjęcia - %mime_type%", 
					  "max_size" => "Zdjęcie za duże - maksymalna wielkość to %max_size% bajtów"
					)
				),
	  'rules' => new sfValidatorString(
    			array('min_length' => 2 ), 
    			array(
    			'min_length' => 'Musisz zaakceptować zasady portalu',
    			'required' => 'Musisz zaakceptować zasady portalu')
    			)
    ));
	$this->widgetSchema->setNameFormat('%s');
	
	$this->validatorSchema->setOption('allow_extra_fields', true);
    $this->validatorSchema->setOption('filter_extra_fields', false);
    
  }
}
